function msgbox(msgtext, optionalParams) {
	$('#modalMsg').off('hidden.bs.modal');
	$('#modalMsg').on('show.bs.modal', function () {
		$("body").addClass("sb_modal_page");
	});
	$('#modalMsg').on('hidden.bs.modal', function () {
		$("body").removeClass("sb_modal_page");
	});

	if (msgtext == undefined || msgtext == "")
		$("#modalMsg").modal('hide');
	else {
		$("#modalMsg .modal-body").html(msgtext);
		if (optionalParams != undefined && optionalParams['title'] != undefined && optionalParams['title'] != "")
			$("#modalMsg .modal-title").text(optionalParams['title']);
		if (optionalParams != undefined && optionalParams['dir'] == "ltr")
			$("#modalMsg .modal-body").css({
				"direction": "ltr"
			});
		if (optionalParams != undefined && optionalParams["login"] === true) {
			$("#modal_login_btn").removeClass("d-none");
		}
		$("#modalMsg").modal('show');

	}
}

function number_format(floatvar, decimallength, sepratorstr) {
	if (sepratorstr == undefined || sepratorstr == "") sepratorstr = ",";
	var intvar = parseInt(floatvar);
	var decimals = floatvar - intvar;
	if (decimallength != undefined)
		var decimalstr = "." + decimals.toFixed(decimallength).toString().substr(2);
	else
		var decimalstr = "";
	var stringint = intvar.toString();
	var stringlength = parseInt(stringint.length);
	var sepcount = parseInt(stringlength / 3);
	var firstchars = parseInt(stringlength % 3);
	var returnstr = "";
	for (var i = 1; i <= sepcount; i++)
		returnstr = sepratorstr + stringint.substr(i * (-3), 3) + returnstr;
	if (firstchars == 0) returnstr = returnstr.substr(1);
	else returnstr = stringint.substr(0, firstchars) + returnstr;
	return returnstr + decimalstr;
}

$("[data-filter_name]").on("click", function () {
	productListFilter($(this).data("filter_name"), $(this).data("filter_value"));
});

urlParse = document.location.toString().match(/profile\/(\w+)/);
if (urlParse != null) $(".sb_profile_tab[data-tab-nav=" + urlParse[1] + "]").trigger("click");

if ($("#archiveFilterAside .sb_filter_box_label input").length > 0) {
	$("[aria-controls=panelsStayOpen-collapseCategories]").trigger("click");
}

if ($("#panelsStayOpen-headingCategories").offset() != undefined && $(".sb_list_tools_bar").length > 0) {
	$("html, body").scrollTop($("#panelsStayOpen-headingCategories").offset().top - 75);
}


// ███████████████████████

$("#pay").on("click", function () {
	var addressID = 0;
	// var deliveryTime = 0;
	// var gateway = 0;
	$("input[name=address_radio]").each(function () {
		if (this.checked) {
			addressID = this.value;
			return false;
		}
	});
	if ($("#checkoutClubDiscount").length>0 && $("#checkoutClubDiscount")[0].checked) var discount=1; else var discount=0;
	msgbox('در حال انتقال به درگاه بانک، لطفاً شکیبا باشید...');
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/orders/new",
		data: "addressID=" + addressID + "&gateway=1&PWA=true&discount="+discount,
		success: function (response) {
			if (response.substr(0, 10) == "redirect: ") document.location = response.substr(10);
			else msgbox(response);
		},
		error: function () {
			msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
		}
	});
});
$("#cna_hozuriRejectBtn, #shippingItemCell .sb_checkout_step_title").on("click", function () {
	$("#shippingItemCell .sb_checkout_step_action_edit").trigger("click");
});

var wishlistW = 0;
function submitWishlist(productID) {
	if (wishlistW == 0) {
		wishlistW = 1;
		$("#wishlistToggleIcon" + productID).parent().css("animation", "blinking 0.5s infinite");
		$.ajax({
			method: "POST",
			url: baseURL + "ajax/users/toggleProductWishlist",
			data: {
				productID: productID
			},
			success: function (response) {
				if (response == 'inserted') {
					$("#wishlistToggleIcon" + productID).removeClass("fa-heart-circle-plus");
					$("#wishlistToggleIcon" + productID).removeClass("fa-regular");
					$("#wishlistToggleIcon" + productID).addClass("fa-solid");
					$("#wishlistToggleIcon" + productID).addClass("text-danger");
					$("#wishlistToggleIcon" + productID).addClass("fa-heart");
				} else if (response == 'deleted') {
					$("#wishlistToggleIcon" + productID).removeClass("fa-solid");
					$("#wishlistToggleIcon" + productID).removeClass("text-danger");
					$("#wishlistToggleIcon" + productID).addClass("fa-regular");
					$("#wishlistToggleIcon" + productID).addClass("fa-heart-circle-plus");
					$("#product-id-is-" + productID).remove();
				} else {
					msgbox('خطایی در کار رخ داده است...');
				}
				wishlistW = 0;
				$("#wishlistToggleIcon" + productID).parent().css("animation", "");
			},
			error: function () {
				wishlistW = 0;
				msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
				$("#wishlistToggleIcon" + productID).parent().css("animation", "");
			}
		});
	}
}

$(".profileOrderRepay").on("click", function () {
	event.preventDefault();
	var urlMatch = document.location.pathname.match('profile\\/orders\\/(\\d+)'); // [original regex] for structure such "profile/order/{oneOrMoreDigits}"
	if (urlMatch != null) {
		msgbox('در حال برقراری ارتباط، لطفاً شکیبا باشید...');
		$.ajax({
			method: "POST",
			url: baseURL + "ajax/orders/repay",
			data: "id=" + urlMatch[1],
			success: function (response) {
				if (response.substr(0, 10) == "redirect: ") document.location = response.substr(10);
				else msgbox(response);
			},
			error: function () {
				msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
			}
		});
	} else console.log('url does not match in .profileOrderRepay.on("click")');
});

function addressProvinceChange(cityTitle) {
	$("#cna_city").html('<option value="0">در حال پردازش، لطفاً شکیبا باشید...</option>');
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/users/provinceCities",
		data: "province=" + $("#cna_state").val() + "&city=" + cityTitle,
		success: function (response) {
			$("#cna_city").html(response);
		},
		error: function () {
			$("#cna_city").html('<option value="0">خطا! دوباره تلاش کنید.</option>');
			msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
		}
	});
};
addressProvinceChange();

function addressEdit(that) {
	var labelElem = $($(that).parents()[2]).find("label");
	$("#cna_fullname").val($(labelElem).find(".sb_address_title").text());
	$("#cna_state").val($(labelElem).find(".sb_address_done_state").data("province_id"));
	addressProvinceChange($(labelElem).find(".sb_address_done_city").text());
	$("#cna_phone").val($(labelElem).find(".userAddressTel").text());
	$("#cna_mobile").val($(labelElem).find(".sb_address_done_mobile").text());
	$("#cna_postalcode").val($(labelElem).find(".sb_address_done_postalCode").text());
	$("#cna_address").val($(labelElem).find(".sb_address_done_address").text());
	$("#cna_address_title").val($(labelElem).find(".sb_card_nickname").text());
	if ($(labelElem).parent().find(".badge").length > 0) {
		$("#checkoutAddrAddForm #flexCheckChecked")[0].checked = true;
		$("#checkoutAddrAddForm #flexCheckChecked").attr("disabled", "disabled");
	} else {
		$("#checkoutAddrAddForm #flexCheckChecked")[0].checked = false;
		$("#checkoutAddrAddForm #flexCheckChecked").removeAttr("disabled");
	}
	$("#input_addressID").val($(labelElem).data("address_id"));
}

$("#cna_removeAddress").on("click", function () {
	var addressID = $(this).data("address_id");
	if (addressID != 0) {
		$("#removeUserAddress .loader_container").addClass("d-flex");
		$.ajax({
			method: "POST",
			url: baseURL + "ajax/users/addressRemove",
			data: "id=" + addressID,
			success: function (response) {
				$("#removeUserAddress").modal('hide');
				$("#removeUserAddress .loader_container").removeClass("d-flex");
				msgbox(response);
				if (response == "حذف آدرس با موفقیت انجام شد.") {
					$($("label[data-address_id=" + addressID + "]").parents()[2]).remove();
					profileCheckAddresses();
					setTimeout(function () {
						console.log("calling deliveryPrice()...");
						deliveryPrice();
					}, 100);
				}
				addressChecked();
			},
			error: function () {
				$("#removeUserAddress .loader_container").removeClass("d-flex");
				msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
			}
		});
	} else {
		msgbox('آدرس مورد نظر یافت نشد!');
		$("#removeUserAddress").modal('hide');
	}
});
$("#removeUserAddress").on("hide.bs.modal", function () {
	$("#cna_removeAddress").data('address_id', 0);
});

$(".checkoutAddrRadio").on("change", function () {
	$('.hozuri').removeClass('active');
	deliveryPrice();
});

function deliveryPrice() {
	var tipaxCityID;
	var addressID=undefined;
	$(".deliveryPriceRow strong, .toPayPriceRow strong").text("؟");
	$(".checkoutAddrRadio").each(function () {
		if (this.checked) {
			tipaxCityID = $(this).data("tipax_id");
			addressID=this.value;
		}
	});
	if (addressID!=undefined) {
		if (addressID==0) $(".mitDeliveryDuration").text(huzuriDuration);
		else $(".mitDeliveryDuration").text(deliveryDuration);
		$("button#pay").removeClass("sb_disable").text("پرداخت آنلاین");
	}

	if ($("#checkoutClubDiscount").length>0 && $("#checkoutClubDiscount")[0].checked) {
		var discountPrice=$("#checkoutClubDiscount").data("discount");
		$(".discountPriceRow").parent().fadeIn(); 
	} else {
		var discountPrice=0;
		$(".discountPriceRow").parent().fadeOut();
	}
	$(".discountPriceRow strong").text(replaceAll(number_format(discountPrice)));

	if (tipaxCityID != undefined) {
		$.ajax({
			method: "POST",
			url: baseURL + "ajax/orders/deliveryPrice",
			data: "destination=" + tipaxCityID,
			success: function (response) {
				var resObj;
				try {
					resObj = JSON.parse(response);
				} catch (e) {
					console.log("deliveryPrice result is not JSON");
				}
				if (resObj != undefined) {
					if (resObj['result'] == "success") {
						$(".deliveryPriceRow strong").text(replaceAll(number_format(resObj.price)));
						$(".toPayPriceRow strong").text(replaceAll(number_format($(".cartPriceRow").data("unformatted_price") + resObj.price - discountPrice)));
					} else msgbox(resObj['msg']);
				} else msgbox('هزینه ارسالِ دریافتی از سرور، معتبر نیست.');
			},
			error: function () {
				$(".deliveryPriceRow strong, .toPayPriceRow strong").text("!");
				msgbox('خطا در محاسبه هزینه ارسال');
			}
		});
	} else {
		if (addressID==0)
		{
			$("#shippingAdrressSubmit").html('مرحله بعد');
			$('#shippingAdrressSubmit').prop('disabled', false);

			$(".deliveryPriceRow strong").text(replaceAll(number_format(30000)));
			$(".toPayPriceRow strong").text(replaceAll(number_format($(".cartPriceRow").data("unformatted_price") + 30000 - discountPrice)));
		}
		else
		{
			$("#shippingAdrressSubmit").html('روش ارسال/دریافت مشخص نشده');
			$('#shippingAdrressSubmit').prop('disabled', true);

			$(".deliveryPriceRow strong, .toPayPriceRow strong").text("؟");
		}
	}
}




// ███████████████████████


function searchHeader() {
	if ($(".sb_header_search input[type=search]").val().trim() != "") {
		document.location = baseURL + "m/search/" + $(".sb_header_search input[type=search]").val()
	} else
		$(".sb_header_search input[type=search]").trigger("click").trigger("focus");
}

function searchHeaderClear() {
	$(".sb_header_search input[type=search]").val('').trigger("click").trigger("focus");
	searchHeaderClearToggle()
}

function searchHeaderClearToggle() {
	if ($(".sb_header_search input[type=search]").val().trim() != "")
		$(".sb_header_trending.sb_taglist .fa-times").css({
			visibility: "visible"
		});
	else
		$(".sb_header_trending.sb_taglist .fa-times").css({
			visibility: "hidden"
		});
}
searchHeaderClearToggle();

function searchProductArchive() {
	if (document.location.pathname.search("category") == -1)
		document.location = baseURL + "search/" + $("#searchInDesc_top").val()
	else {
		var urlMatch = document.location.pathname.match('category\\/([\\w-]+)'); // [original regex] must have a combination of unicode word with or without dashes in between that comes after "category/"
		document.location = baseURL + "category/" + urlMatch[1] + "/search/" + $("#searchInDesc_top").val()
	}
}
var searchHeaderAjaxRequest;

function searchHeaderAjax() {
	$(".searchMiniResults").html("در حال پردازش...");
	if (searchHeaderAjaxRequest != undefined) searchHeaderAjaxRequest.abort();
	searchHeaderAjaxRequest = $.ajax({
		method: "POST",
		url: baseURL + "ajax/products/search",
		data: "q=" + $(".sb_header_search input[type=search]").val() + "&cat=all&PWA=true",
		success: function (response) {
			$(".searchMiniResults").html(response);
		},
		error: function (errorObj) {
			if (errorObj.statusText != "abort") $(".searchMiniResults").html("خطا در دریافتِ خلاصه‌ی نتایج جستجو");
		}
	});
}
$(".sb_header_search_box input").on("focus keyup", function () {
	searchHeaderAjax();
});

function windowResize() {
	var vpw = $("html, body").width();
	var vph = $("html, body").height();


	$(".searchMiniResults").css({
		"width": $(".sb_header_search_inner").width() - 4,
		"left": $(".sb_header_search_inner")[0].offsetLeft + 2,
		"top": $(".sb_header_search_inner")[0].offsetTop + 30
	});
}
windowResize();
$(window).on("resize", windowResize);

// ███████████████████████

// CART OVERLAY
function cartAjax(action) {
	if (action != "loading" && action != "open" && action != "refresh" && action != "open&refresh") action = "open&refresh";
	$('.sb_cart_overlay .loader_container').addClass('d-flex');
	if (action != "loading") {
		if (action == "open" || action == "open&refresh")
			setTimeout(function () {
				$("#register_login_modal").modal('hide');
				$("#pwaSearchModal").modal('hide');
				var classAddResult = $('.sb_cart_overlay').addClass('is_active');
				$('body').addClass('sb_basket_open');
				$('#pwa_cart').addClass('active');
			}, 10);

		if (action == "refresh" || action == "open&refresh") {
			$.ajax({
				url: baseURL + "ajax/cart/list",
				type: 'GET',
				success: function (response) {
					$('.sb_cart_overlay .loader_container').removeClass('d-flex');
					$(".sb_cart_category, #cartOverlayCount, #cartOverlayPriceSum").remove();
					$(".sb_cart_empty").after(response);

					$('.sb_cart_category .sb_quantity_plus').on('click', function (e) {
						e.stopPropagation();
						quantityFunc($(this), 'sum');
					});
					$('.sb_cart_category .sb_quantity_minus').on('click', function (e) {
						e.stopPropagation();
						quantityFunc($(this), 'minus');
					});

					$("#cartPaneCount").text($("#cartOverlayCount").text());
					$("#cartPanePrice").text($("#cartOverlayPriceSum").text());
					isCartEmpty();
				},
				error: function (errorMessage) {
					$('.sb_cart_overlay .loader_container').removeClass('d-flex');
					msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
				}
			});
		}
	}
}

function quantityFunc(element, action, withoutAjax) {
	if (withoutAjax != true) withoutAjax = false;
	$('.sb_quantity_btn').addClass('disabled');
	cartAjax("loading");

	$(".cartPacking").html('<a href="#">محاسبه مجدد</a>').on("click", function () {
		event.preventDefault();
		document.location.reload();
	});
	var id = element.parent().data("product_id");

	let $quantityNum = $(".cartPro" + id + "_QTY");
	let num = Number($quantityNum.html());

	if (action == 'sum') {
		num++;
		$('.sb_quantity[data-product_id=' + id + ']').find('.fa-trash-can').removeClass('fa-trash-can').addClass('fa-minus');
		$(".pro" + id + "_addBtn").text("موجود در سبد خرید");
		$(".pro" + id + "_addBtn").parent().attr("onclick", "");
		$(".pro" + id + "_addBtn").parent().off("click");
		$(".pro" + id + "_addBtn").parent().on("click", function () {
			cartAjax();
		});
		$(".proSingleMobileCartQTY").removeClass("d-none");
	} else if (action == 'minus') {
		num--;
		if (num == 1)
			$('.sb_quantity[data-product_id=' + id + ']').find('.fa-minus').removeClass('fa-minus').addClass('fa-trash-can');
		else if (num == 0) {
			$('.sb_btn_added_basket').removeClass('d-flex');
			$('.sb_btn_not_added_basket').removeClass('d-none');
			$(".pro" + id + "_addBtn").text("افزودن به سبد خرید");
			$(".pro" + id + "_addBtn").parent().attr("onclick", "");
			$(".pro" + id + "_addBtn").parent().off("click");
			$(".pro" + id + "_addBtn").parent().on("click", function () {
				cart_add(id, 1);
			});
			$(".proSingleMobileCartQTY").addClass("d-none");
		}
	}
	$quantityNum.html(num);
	if (num == 0) $(".proSingleCartQTY").text("1"); // preparing default value for next time adding to cart

	var totalPrice, thisNum, thisID;
	var cartTotal = 0;
	$("[data-price]").each(function () {
		thisNum = $($(this).parents()[3]).find(".sb_quantity_num").text();
		totalPrice = thisNum * parseInt($(this).data("price"));

		thisID = $($(this).parents()[3]).find("[data-product_id]").data("product_id");
		$("#cartPro" + thisID + "_totalPrice").text(replaceAll(number_format(totalPrice)));

		cartTotal += totalPrice;
	});
	$("#cartItemsTotal").data("cart_items_total", cartTotal).text(replaceAll(number_format(cartTotal)));
	var toPay = cartTotal /*  + $("#deliveryPrice").data("delivery_price") */;
	$(".cartTotalPrice").data("to_pay_price", toPay).text(replaceAll(number_format(toPay)));

	if (!withoutAjax) { // when called in withoutAjax mode, it's usually just for undoing an failed ajax
		$.ajax({
			method: "POST",
			url: baseURL + "ajax/cart/edit",
			data: {
				"id": id,
				"count": num
			},
			success: function (response) {
				responseArr = JSON.parse(response);
				if (responseArr.msg == "productPriceID not found" || responseArr.msg == 'محصول مورد نظر در سبد خرید یافت نشد!') {
					$('.sb_quantity_btn').removeClass('disabled');
					msgbox('تغییر تعداد با خطا مواجه شد، لطفاً صفحه را نوسازی/رفرش کنید و مجدداً تلاش کنید.');
					if (action == "sum") quantityFunc(element, "minus", true);
					else quantityFunc(element, "sum", true);
				} else if (responseArr.msg == "stock is below desired count") {
					$('.sb_quantity_btn').removeClass('disabled');
					msgbox('تغییر تعداد ممکن نیست، موجودی این آیتم در انبار کمتر از تعداد درخواستی شماست.');
					if (action == "sum") quantityFunc(element, "minus", true);
					else quantityFunc(element, "sum", true);
				} else if (responseArr.msg.substr(0, 9) == "limit is ") {
					$('.sb_quantity_btn').removeClass('disabled');
					msgbox('خطا! از این آیتم می‌توانید حداکثر ' + replaceAll(responseArr.msg.substr(9)) + ' عدد به سبد خرید خود اضافه کنید.');
					if (action == "sum") quantityFunc(element, "minus", true);
					else quantityFunc(element, "sum", true);
				} else if (responseArr.msg.substr(0, 19) == "limit in 24 hours: ") {
					$('.sb_quantity_btn').removeClass('disabled');
					msgbox('خطا! از این آیتم در هر ۲۴ ساعت می‌توانید حداکثر ' + replaceAll(responseArr.msg.substr(19)) + ' عدد خریداری کنید.');
					if (action == "sum") quantityFunc(element, "minus", true);
					else quantityFunc(element, "sum", true);
				} else {
					if ($(".sb_summary_actions").length > 0) document.location.reload();

					$('.sb_quantity_btn').removeClass('disabled');
					if (responseArr.msg == "حذف از سبد خرید با موفقیت انجام شد.")
						$("#cartRow" + id).remove();

					if ($("#cartRows").length > 0 && $("#cartRows").children().length <= 0)
						document.location = baseURL + "cart";

					$("#cartCountElem").text("(" + replaceAll(responseArr.count) + ")");
					if ($(".sb_cart_overlay").hasClass("is_active")) cartAjax("refresh");
					pwaStateClickAssign();
				}
				cartCheck(id);
			},
			error: function () {
				$('.sb_quantity_btn').removeClass('disabled');
				msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
				if (action == "sum") quantityFunc(element, "minus", true);
				else quantityFunc(element, "sum", true);
			}
		});
	} else $('.sb_quantity_btn').removeClass('disabled');
}

function isCartEmpty() {
	let emptyCart = false;
	if ($('.sb_cart_overlay_middle').children().length == 1) {
		$('.sb_cart_empty').removeClass('d-none');
		$('#goToCheckout').addClass('disabled');
		$('#goToCart').addClass('disabled');
		emptyCart = true;
	} else {
		$('.sb_cart_empty').addClass('d-none');
		$('#goToCheckout').removeClass('disabled');
		$('#goToCart').removeClass('disabled');
	}
	return emptyCart;
}

// ██ cartCheck function only works fine on productSingle, using it on Cart or other pages may result bugs
function cartCheck(id) {
	$(".sb_product_buy_box .sb_price_current strong, .sb_product_bar .sb_price_current strong, .sb_price.d-lg-none strong").text($("#proSinglePrice" + id).text());

	if ($("#proSinglePrice" + id).data("price_before_discount") > 0 && $("#proSinglePrice" + id).data("price_before_discount") > $("#proSinglePrice" + id).data("price")) {
		$(".sb_product_pane .sb_price_was .sb_price_was_data, .sb_product_wrapp_inner .sb_price_was .sb_price_was_data").text(replaceAll(number_format($("#proSinglePrice" + id).data("price_before_discount"))));
		var priceDiff = parseInt($("#proSinglePrice" + id).data("price_before_discount")) - parseInt($("#proSinglePrice" + id).data("price"));
		$(".sb_product_pane .sb_price_save_price span:first-child, .sb_product_wrapp_inner .sb_price_save_price span:first-child").text(replaceAll(number_format(priceDiff)));
		$(".sb_product_pane .sb_price_save_percent, .sb_product_wrapp_inner .sb_price_save_percent").text(replaceAll(Math.round((priceDiff / $("#proSinglePrice" + id).data("price_before_discount")) * 100)) + "%");
		$(".sb_product_pane .sb_price_was, sb_product_pane .sb_price_map, .sb_product_pane .sb_price_save").removeClass("d-none");
		$(".sb_product_wrapp_inner .sb_price_was, sb_product_wrapp_inner .sb_price_map, .sb_product_wrapp_inner .sb_price_save").removeClass("d-none");
	} else {
		$(".sb_product_pane .sb_price_was, sb_product_pane .sb_price_map, .sb_product_pane .sb_price_save").addClass("d-none");
		$(".sb_product_wrapp_inner .sb_price_was, sb_product_wrapp_inner .sb_price_map, .sb_product_wrapp_inner .sb_price_save").addClass("d-none");
	}

	$(".sb_mobile_bar > .row").html("<p>در حال بررسی، لطفاً شکیبا باشید...</p>");
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/cart/check",
		data: {
			"id": id,
			"PWA": true
		},
		success: function (response) {
			$(".sb_mobile_bar > .row").html(response); //changing content of productSingle addToCartBlock
			var oldPriceID = $(".proSingleMobileCartQTY").data("product_id"); //storing oldPriceID from mobileBar

			$(".proSingleMobileCartQTY").data("product_id", id); //changing priceID of mobileBar to new priceID
			$(".cartPro" + oldPriceID + "_QTY").removeClass("cartPro" + oldPriceID + "_QTY").addClass("cartPro" + id + "_QTY"); //changing priceID of mobileBar & addToCartBlock quantityIndicator to new priceID
			$(".pro" + oldPriceID + "_addBtn").removeClass("pro" + oldPriceID + "_addBtn").addClass("pro" + id + "_addBtn"); //changing priceID of fixedBar & mobileBar addToCart buttons to new priceID

			$(".sb_mobile_bar .sb_quantity_plus").on("click", function () {
				quantityFunc($(this), "sum");
			}); //adding onClick of mobileBar quantityPlusButton
			$(".sb_mobile_bar .sb_quantity_minus").on("click", function () {
				quantityFunc($(this), "minus");
			}); //adding onClick of mobileBar quantityMinusButton
			pwaStateClickAssign();
			document.getElementById('archiveCompare').addEventListener('click', archiveCompareFunc);
		},
		error: function () {
			$(".sb_mobile_bar > .row").html("خطا در اتصال! از کارکرد صحیح اینترنتتان اطمینان حاصل کرده و صفحه را نوسازی کنید.");
			console.log('connection error in cartCheck(id: ' + id + ')');
		}
	});
}

function cart_add(id, count) {
	// cartAjax("open");
	// document.location.hash="#basket";
	$('.sb_btn_not_added_basket').addClass('d-none');
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/cart/add",
		data: {
			"id": id,
			"count": count
		},
		success: function (response) {
			if (response == "productPriceID not found") {
				msgbox('افزودن به سبد خرید با خطا مواجه شد، لطفاً صفحه را نوسازی/رفرش کنید و مجدداً تلاش کنید.');
				$('.sb_btn_not_added_basket').removeClass('d-none');
			} else if (response == "stock is below desired count") {
				msgbox('موجودی این آیتم به اتمام رسیده است، لطفاً صفحه را نوسازی/رفرش کنید و مجدداً تلاش کنید.');
				$('.sb_btn_not_added_basket').removeClass('d-none');
			} else if (response.substr(0, 9) == "limit is ") {
				msgbox('خطا! از این آیتم می‌توانید حداکثر ' + replaceAll(response.substr(9)) + ' عدد به سبد خرید خود اضافه کنید.');
				$('.sb_btn_not_added_basket').removeClass('d-none');
			}
			else if (response.substr(0, 19) == "limit in 24 hours: ") {
				msgbox('خطا! از این آیتم در هر ۲۴ ساعت می‌توانید حداکثر ' + replaceAll(response.substr(19)) + ' عدد خریداری کنید.');
				$('.sb_btn_not_added_basket').removeClass('d-none');
			} else {
				cartAjax("refesh");
				$('.sb_btn_added_basket').addClass('d-flex');
				$(".pro" + id + "_addBtn").text("موجود در سبد خرید");
				$(".pro" + id + "_addBtn").parent().attr("onclick", "");
				$(".pro" + id + "_addBtn").parent().off("click");
				$(".pro" + id + "_addBtn").parent().on("click", function () {
					cartAjax();
				});
				$(".proSingleMobileCartQTY").removeClass("d-none");

				if ($("#productBuy .cartPro" + id + "_QTY").text() <= 1) $(".sb_mobile_bar .sb_quantity_minus i, #productBuy .sb_quantity_minus i").removeClass("fa-minus").addClass("fa-trash-can");
				else $(".sb_mobile_bar .sb_quantity_minus i, #productBuy .sb_quantity_minus i").addClass("fa-minus").removeClass("fa-trash-can");
			}
			cartCheck(id);
			pwaStateClickAssign();
		},
		error: function () {
			msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
			$('.sb_btn_not_added_basket').removeClass('d-none');
		}
	});
}

function cart_remove(id) {
	event.preventDefault();
	var qtyElem = $(".cartPro" + id + "_QTY")[0];
	$(qtyElem).text("1");
	$(qtyElem).next().trigger("click");
}


// ███████████████████████

function profileLastOrder() {
	$(".profileDashboardLastOrder").html($(".profileLastOrder").html());
	$(".profileDashboardLastOrder button").remove();
	$(".profileDashboardLastOrder").on("click", function () { $(".profileLastOrder").trigger("click"); });
}
profileLastOrder();

function profileOrderDetails(orderID) {
	$(".sb_profile_order_item_more").html('در حال بارگذاری، لطفاً شکیبا باشید...');
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/orders/details",
		data: "orderID=" + orderID,
		success: function (response) {
			$(".sb_profile_order_item_more").html(response);
		},
		error: function () {
			$(".sb_profile_order_item_more").html('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
		}
	});
}

function profileCheckAddresses() {
	if ($(".row.sb_checkout_card_cells").children().length > 0) {
		$(".profileAddressesEmpty").hide();
		$(".profileAddressesNotEmpty").show();
	} else {
		$(".profileAddressesEmpty").show();
		$(".profileAddressesNotEmpty").hide();
	}
}
profileCheckAddresses();

function profileUpdateBasicInfo() {
	msgbox('در حال پردازش، لطفاً شکیبا باشید...');
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/users/updateBasicInfo",
		data: $("#profileBasicInfo").serialize(),
		success: function (response) {
			msgbox(response);
		},
		error: function () {
			msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
		}
	});
}
function profileUpdatePassword() {
	msgbox('در حال پردازش، لطفاً شکیبا باشید...');
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/users/updatePassword",
		data: $("#profilePassword").serialize(),
		success: function (response) {
			msgbox(response);
		},
		error: function () {
			msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
		}
	});
}

var profileOrderLimitFrom = 5;
function profileMoreOrders() {
	event.preventDefault();
	msgbox('در حال پردازش، لطفاً شکیبا باشید...');
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/orders/more",
		data: "limitFrom=" + profileOrderLimitFrom + "&PWA=true",
		success: function (response) {
			msgbox();
			if (response != "") {
				$("#profileOrderLoadMore").before(response);
				profileOrderLimitFrom += 5;
				openModalAssign();
				pwaStateClickAssign();
			} else {
				$("#profileOrderLoadMore").remove();
				msgbox('سفارشِ قدیمی‌تری از شما یافت نشد.');
			}
		}, error: function () {
			msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
		}
	});
}


// ███████████████████████


var initialProductSeriesForm = $(".sb_product_option.sb_form_cells").html();

function narrowProductsInSeries(seriesID, productIDsStr, selectedParamVal) {
	if (event) event.preventDefault();
	$(".sb_product_option.sb_form_cells").html("<p>در حال پردازش، لطفاً شکیبا باشید...</p>");
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/productseries/narrowProducts",
		data: {
			"seriesID": seriesID,
			"productIDs": productIDsStr,
			"selectedParamVal": selectedParamVal
		},
		success: function (response) {
			$(".sb_product_option.sb_form_cells").html(response);
		},
		error: function () {
			resetProductSeries(true);
			console.log('connection error in narrowProductsInSeries(seriesID: ' + seriesID + ', productIDsStr: ' + productIDsStr + ')');
		}
	});
}

function resetProductSeries(showError) {
	if (event) event.preventDefault();
	var errorHtml = "";
	if (showError != true) showError = false;
	if (showError)
		errorHtml = '<p style="color: var(--sb-secondary1); font-size: 12px; font-weight: 800">خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.</p>';
	$(".sb_product_option.sb_form_cells").html(errorHtml + initialProductSeriesForm);
}

function productListFilter(getParamName, getParamVal) {
	msgbox('لطفا شکیبا باشید...');
	var addIfNotExists = true;

	var newGetStr = "?";
	var regex = /(\w+)=((\w+)|\[[^&]+\])/gm; // var regex = /(\w+)=(\w+)/gm;
	var m;

	while ((m = regex.exec(document.location.search)) !== null) {
		if (m.index === regex.lastIndex) regex.lastIndex++; // traversing all params from currentURL

		// getParamName is found on currentURL, value might be changed
		if (m[1] == getParamName) {
			// getParamName is "sort" or "available", value can be simply changed
			if (m[1].substr(0, 1) !== "p") newGetStr += getParamName + "=" + getParamVal + "&";

			// getParamName is one of dynamicParameters, value must be pushed or pulled from JSON
			else {
				var currentValArr = JSON.parse(decodeURI(m[2]));
				if (currentValArr.indexOf(getParamVal) < 0) currentValArr.push(getParamVal);
				else {
					var newArrWithoutGetParamVal = [];
					currentValArr.forEach(function (arrItem) { if (arrItem != getParamVal) newArrWithoutGetParamVal.push(arrItem); });
					currentValArr = newArrWithoutGetParamVal;
				}
				var updatedValJSON = JSON.stringify(currentValArr);
				if (currentValArr.length > 0) newGetStr += getParamName + "=" + updatedValJSON + "&";
				else addIfNotExists = false;
			}
		}

		// all other parameters from currentURL except "page" will be passed to newGetStr with their unchanged values
		else if (m[1] != "page") newGetStr += m[1] + "=" + m[2] + "&";
	}

	// getParamName was not found on currentURL so we add it to newGetStr
	if (newGetStr.search(getParamName) == -1 && addIfNotExists) {
		if (getParamName.substr(0, 1) !== "p") newGetStr += getParamName + "=" + getParamVal;
		else {
			var newValArr = [getParamVal];
			var newValJSON = JSON.stringify(newValArr);
			newGetStr += getParamName + "=" + newValJSON;
		}
	}
	else newGetStr = newGetStr.substr(0, newGetStr.length - 1);

	document.location = document.location.pathname + newGetStr;
}

$(".ratingInputOption").on("mouseenter", function () {
	$(this).parent().prev().removeClass("rating-0 rating-0-5 rating-1 rating-1-5 rating-2 rating-2-5 rating-3 rating-3-5 rating-4 rating-4-5 rating-5");
	$(this).parent().prev().addClass("rating-" + $(this).data("rating_value"));
});
$(".ratingInput").on("mouseleave", function () {
	$(this).children("i.rating").removeClass("rating-0 rating-0-5 rating-1 rating-1-5 rating-2 rating-2-5 rating-3 rating-3-5 rating-4 rating-4-5 rating-5");
	$(this).children("i.rating").addClass("rating-" + $(this).children("input").val());
});
$(".ratingInputOption").on("click", function () {
	$(this).parent().prev().prev().val($(this).data("rating_value"));
});

function checkoutSaleTypeNotice() {
	event.preventDefault();
	msgbox('در صورتیکه اطلاعاتِ حقوقیِ شرکت یا فروشگاه خود را در <a class="text-primary" href="' + baseURL + 'profile">صفحه پروفایل</a> کامل کرده باشید، خریدتان بصورتِ رسمی و با هویتِ حقوقی‌تان در سامانه‌ی سازمان امور مالیاتی ثبت خواهد شد.');
}

function getCountProductsInCart() {
	$.ajax({
		method: "POST",
		url: baseURL + "ajax/cart/count",
		success: function (response) {
			if (response >= 1) {
				$(".count_products_in_cart").removeClass('d-none');
				$("#countProductsInCart").html(replaceAll(response));
			} else {
				$(".count_products_in_cart").addClass('d-none');
			}
			setTimeout(getCountProductsInCart, 3000);
		},
		error: function () {
			$(".count_products_in_cart").addClass('d-none');
			setTimeout(getCountProductsInCart, 3000);
		}
	});
}

getCountProductsInCart();
