"use strict";

var preloaderAnimation;
var param = ({
	container: document.getElementById('Loader_animation'),
	renderer: 'svg',
	loop: true,
	autoplay: true,
	path: `${baseURL}assets/json/preloader.json`,
});
preloaderAnimation = lottie.loadAnimation(param);

window.addEventListener("pageshow", function () {
	console.log("pageshow");
	$(".mitPWApreloader").delay("slow").fadeOut("slow", () => {
		preloaderAnimation.stop();
	});
});


$(window).on("beforeunload ", function () {
	console.log("beforeunload");
	$(".mitPWApreloader").css({ 'display': 'flex' }, () => {
		preloaderAnimation.play();
	});
});

$(".fj_menu_list_link").on('click', function () {
	console.log("touched-a");
	$(".mitPWApreloader").css({ 'display': 'flex' }, () => {
		preloaderAnimation.play();
	});
});

var refresher;

if ('serviceWorker' in navigator) {
	// Register a service worker hosted at the root of the
	// site using the default scope.
	navigator.serviceWorker.register('service-worker020629-6.js').then(function (registration) {
		// console.log('Service worker registration succeeded:', registration);
	}, /*catch*/ function (error) {
		// console.log('Service worker registration failed:', error);
	});
} else {
	// console.log('Service workers are not supported.');
}

function interactHeaderSearch() {
	$(".sb_header_search").addClass("is_active");
	// $(".sb_masker").on("click", function () {
	// 	$(this).remove();
	// 	$(".sb_header_search").removeClass("is_active");
	// 	$(".searchMiniResults").removeClass("d-flex");
	// 	$("body").css("overflow", "visible");
	// 	$(".sb_header_right_section  .sb_masker").remove();
	// });
	$(".searchMiniResults").addClass("d-flex");
	$("body").css("overflow", "hidden");
	// searchHeaderAjax();
	$(".sb_header_search input").trigger("focus");
}

let rotate = 0;

function replaceAll(str) {
	str = str.toString();
	str = str.replace(/0/g, "۰");
	str = str.replace(/1/g, "۱");
	str = str.replace(/2/g, "۲");
	str = str.replace(/3/g, "۳");
	str = str.replace(/4/g, "۴");
	str = str.replace(/5/g, "۵");
	str = str.replace(/6/g, "۶");
	str = str.replace(/7/g, "۷");
	str = str.replace(/8/g, "۸");
	str = str.replace(/9/g, "۹");
	return str;
}
let sb_masker = document.createElement("div");
sb_masker.setAttribute("class", "sb_masker");
// enable bs popover
var popoverTriggerList = [].slice.call(
	document.querySelectorAll('[data-bs-toggle="popover"]')
);
var popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
	return new bootstrap.Popover(popoverTriggerEl);
});
// scroll to top
$("#sb_To_Top").click(function () {
	$("html, body").animate({
		scrollTop: 0,
	},
		"slow"
	);
	return false;
});
// sticky header on scroll
$(window).scroll(function () {
	if (document.body.scrollTop) var scrollTop = document.body.scrollTop;
	else var scrollTop = document.documentElement.scrollTop;

	// show / hide scrollToTop btn
	if (scrollTop > 20) {
		$("#sb_To_Top").removeClass("d-none");
	} else {
		$("#sb_To_Top").addClass("d-none");
	}

	// product single
	if (scrollTop > 100) {
		$(".sb_product_bar").addClass("is_fixed");
	} else {
		$(".sb_product_bar").removeClass("is_fixed");
	}

	// compare fixe compare-items-bar
	if (scrollTop > 300) {
		$(".sb_compare_items_bar").addClass("is-active");
	} else {
		$(".sb_compare_items_bar").removeClass("is-active");
	}

	// sticky menu
	var sticky = $("#sb_main_header"),
		scroll = $(window).scrollTop();
	if (scroll >= 100) sticky.addClass("is_sticky");
	else sticky.removeClass("is_sticky");

	$("[data-lazyloadsrc]").each(function () {
		if ($(this).offset().top <= scrollTop + window.innerHeight) {
			$(this).attr("src", $(this).data("lazyloadsrc"));
			$(this).removeAttr("data-lazyloadsrc");
		}
	});
});


function addressChecked() {
	var selectedRadio;
	$("[name=address_radio]").each(function () {
		if (this.checked) {
			selectedRadio = this;
			return false;
		}
	});
	if (selectedRadio != undefined) {
		$('#pay').removeClass('sb_disable');
		$('#pay').prop('disabled', false);
		$('#pay').html('پرداخت آنلاین');

		return;
	} else {
		$('#pay').addClass('sb_disable');
		$('#pay').prop('disabled', true);
		$('#pay').html('لطفا نحوه دریافت سفارش را انتخاب نمایید');
	}
}

// on page load
$(function () {
	// validation field
	const messages = {
		valueMissing: () => "مقدار اجباری میباشد",
		patternMismatch: () => "فرمت وارد شده اشتباه است",
		tooShort: (target) => `حداقل باید ${target.minLength} کاراکتر وارد شود`,
		//
		serverProb: () => "مشکلی رخ داده است مجدد تلاش کنید",
		loginNoExist: () => "کاربری با این شماره موبایل موجود نمی باشد",
		registerExist: () => "این شماره موبایل قبلاً ثبت نام نموده است",
		wrongPass: () => "رمز عبور اشتباه است",
	};
	const validityKeys = Object.keys(messages);
	let sb_validate = [];

	function checkValidityForm(target) {
		sb_validate = [];
		validityKeys.forEach((key) => {
			if (target.validity[key]) {
				appendError(key, target);
				sb_validate.push(target.validity[key]);
			} else {
				sb_validate.push(target.validity[key]);
			}
			// console.log(sb_validate);
		});
		if (sb_validate.includes(true)) {
			return false;
		}
		return true;
	}

	function removeError(target) {
		const errorEl =
			target.parentElement.parentElement.querySelectorAll("small");
		errorEl.forEach((el) => el.remove());
	}

	function appendError(key, target) {
		const errorEl = document.createElement("small");
		errorEl.setAttribute("class", "sb-form-error");
		errorEl.innerText = messages[key] ? messages[key](target) : key;
		target.parentElement.parentElement.prepend(errorEl);
	}

	// ███████████████████████
	// register login modal
	// ███████████████████████
	// animate card
	let prevAnimateCardData;

	function NextAnimateCards(targetData) {
		prevAnimateCardData = $(".sb_log_reg_container.sb_form_active").attr(
			"data-login-form"
		);
		$(".sb_log_reg_container").each(function () {
			if (targetData == $(this).attr("data-login-form")) {
				$(this).addClass("sb_form_active");
				$(this).siblings().removeClass("sb_form_active");
			}
		});
		$(".sb_log_reg_container.sb_form_active .sb_form_btn_back").attr(
			"data-login-form",
			prevAnimateCardData
		);
	}

	function prevAnimateCards(prevAnimateCardData) {
		$(".sb_log_reg_container").each(function () {
			if (prevAnimateCardData == $(this).attr("data-login-form")) {
				$(this).addClass("sb_form_active");
				$(this).siblings().removeClass("sb_form_active");
			}
		});
	}
	let t;
	let time = 0;

	function createTimerSmsCode() {
		$("#smsCodeAgain").prop("disabled", true);
		let smsCodeAgainElem = document.getElementById("smsCodeAgain");
		time = 60;
		t = setInterval(() => {
			time--;
			smsCodeAgainElem.innerHTML = time + " ثانیه ";
			if (time == 0) {
				clearInterval(t);
				smsCodeAgainElem.innerHTML = "ارسال مجدد";
				$("#smsCodeAgain").prop("disabled", false);
			}
		}, 1000);
	}
	// listeners
	$("#createAccount").on("click", function (e) {
		NextAnimateCards($(this).attr("data-login-form"));
	});
	$(".sb_form_btn_back").on("click", function () {
		prevAnimateCards($(this).attr("data-login-form"));
	});
	$('input[name="sb_login_user_data"]').on('keyup', function () {
		var value = $(this).val();
		$('input[name="sb_reg_user_data"]').val(value).prop('disabled', true);
		$('.sb_log_show_mob_number').text(value);
	});




	$(".sb_validate").keypress(function (e) {
		var key = e.which;
		if (key == 13) {
			$(this).closest('.sb_validate_key_parent').find('.sb_validate_key').click();
			return false;
		}
	});

	let passFalse;
	$("[data-form-status]").on("click", function (e) {
		let request = e.target.getAttribute("data-form-status");
		let input = e.target.parentElement.querySelector("input");
		console.log(input);
		$("[name=sb_sms_user_data]").val(input.value);
		if (request == "smsCode" && time > 0) {
			NextAnimateCards("regSms");
		} else if (request == "smsCode" && passFalse) {
			NextAnimateCards("regSms");
			loginRegisterRequest($("[name=sb_login_user_data]")[0], request);
			$("[name=sb_sms_user_data]").val($("[name=sb_login_user_data]").val());
		} else if (request == "smsCode" && time == 0) {
			NextAnimateCards("regSms");
			loginRegisterRequest(input, request);
		} else {
			loginRegisterRequest(input, request);
		}
	});

	$('#fj_pass_back').on('click', function () {
		restartLoginProcess();
	});

	function restartLoginProcess() {
		passFalse = false;
		time = 0;
		$('input[name="sb_login_user_data"]').val('');
		$('input[name="sb_user_pass"]').val('');
		$('#loginPass').trigger('click');
	}



	function loginRegisterRequest(inputElem, requestType) {

		removeError(inputElem);
		if (checkValidityForm(inputElem)) {
			$("#register_login_modal .loader_container").addClass("d-flex");
			$.ajax({
				url: baseURL + "ajax/users/loginRegister",
				type: "POST",
				data: {
					userMobile: inputElem.value,
					userRequest: requestType,
				},
				success: function (response) {
					response = JSON.parse(response);
					$("#register_login_modal .loader_container").removeClass("d-flex");
					// let responseReq = response.responseReq; /* 'login' */
					let responseUserExist = response.responseUserExist; /* true */
					let loginSuccessful =
						response.loginSuccessful; /* responseUserPass = true */
					switch (requestType) {
						// case "register":
						// 	if (responseUserExist) {
						// 		if (response.hasPass) NextAnimateCards("passSection");
						// 		else {
						// 			NextAnimateCards("regSms");
						// 			$(".sb_log_show_mob_number").html($(inputElem).val());
						// 			if (time == 0) loginRegisterRequest(inputElem, "smsCode");
						// 		}
						// 		appendError("registerExist", inputElem);
						// 	} else {
						// 		$(".sb_log_show_mob_number").html($(inputElem).val());
						// 		NextAnimateCards("regSms");
						// 		if (time == 0) loginRegisterRequest(inputElem, "smsCode");
						// 	}
						// 	break;
						case "smsCode":
							$(".sb_log_show_mob_number").html($(inputElem).val());
							createTimerSmsCode();
							break;
						case "smsCodeAgain":
							if (response.error != undefined)
								appendError(response.error, inputElem);
							else createTimerSmsCode();
							break;
						case "finalizeCode":
							if (loginSuccessful) document.location = document.location.origin + document.location.pathname;
							else {
								if (response.error != undefined)
									appendError(response.error, inputElem);
								else appendError("serverProb", inputElem);
							}
							break;
						case "login":
							if (responseUserExist) {
								if (response.hasPass) NextAnimateCards("passSection");
								else {
									NextAnimateCards("regSms");
									if (time == 0) loginRegisterRequest(inputElem, "smsCode");
								}
							} else {
								NextAnimateCards('register');
							}
							break;
						case "loginPass":
							if (loginSuccessful) {
								if (loginSuccessful) document.location = document.location.origin + document.location.pathname;
							} else {
								appendError("wrongPass", inputElem);
								passFalse = true;
							}
							break;
						default:
							console.log("default case happened! requestType: " + requestType);
							break;
					}
				},
				error: function (errorMessage) {
					$("#register_login_modal .loader_container").removeClass("d-flex");
				},
			});
		}
	}


	// ███████████████████████
	// Sliders
	// ███████████████████████
	// hero-slider
	const swiper = new Swiper(".sb_hero_slider", {
		// Optional parameters
		slidesPerView: 1,
		spaceBetween: 10,
		centeredSlides: true,
		direction: "horizontal",
		loop: false,
		autoplay: {
			delay: 3000,
		},
		// Navigation arrows
		pagination: {
			el: ".hero-swiper-pagination",
		},
		navigation: {
			nextEl: ".swiper-button-next",
			prevEl: ".swiper-button-prev",
		},

	});

	// categories-home-slider
	const swiper_categories = new Swiper(".sb_categories_nav_swiper", {
		// Optional parameters
		freeMode: true,
		preventClicks: true,
		a11y: false,
		slidesPerView: 'auto',
		spaceBetween: 20,
		// grid: {
		// 	rows: 2,
		// },
		autoplay: {
			delay: 3000,
		},
		pagination: {
			el: ".categories-swiper-pagination",
		},

	});
	// common slider
	const swiper_container = new Swiper(".sb_swiper_container", {
		// Optional parameters
		direction: "horizontal",
		loop: false,
		spaceBetween: 20,
		scrollbar: {
			el: ".swiper-scrollbar",
			hide: true,
		},
		breakpoints: {
			320: {
				slidesPerView: 2,
			},
			576: {
				slidesPerView: 4,
			},
			768: {
				slidesPerView: 7,
			},
			992: {
				slidesPerView: 8,
			},
			1200: {
				slidesPerView: 10,
			},
		},
	});
	// header menu slider
	const swiper_header_menu = new Swiper(".sb_header_swiper", {
		loop: false,
		freeMode: true,
		spaceBetween: 20,
		autoplay: true,
		slidesPerView: 'auto',
		nav: true,
		scrollbar: {
			el: ".swiper-scrollbar",
			hide: true,
		},
	});

	// ███████████████████████
	// Header
	// ███████████████████████
	// change select option search box header
	$(".sb_header_search_whitin select").on("change", function () {
		let selectedVal = $(this).find(":selected").text();
		$(".sb_header_search_whitin_name").html(selectedVal);
		$(".sb_header_search_box input").focus();
		interactHeaderSearch();
	});
	// switch DARK/LIGHT mode
	let checkDarkMode = $("#checkdarkmode");
	let $html = $("html");
	checkDarkMode.on("click", (e) => {
		$html.toggleClass("dark_mode");
		localStorage.setItem("theme_mode", $html.attr("class"));
		if ($html.hasClass("dark_mode"))
			$("img.brandLogo").each(function () {
				$(this).attr("src", $(this).data("logo_dark"));
			});
		else
			$("img.brandLogo").each(function () {
				$(this).attr("src", $(this).data("logo_light"));
			});
	});
	if (localStorage.getItem("theme_mode") == "dark_mode") {
		$("#checkdarkmode").prop("checked", true);
		$("img.brandLogo").each(function () {
			$(this).attr("src", $(this).data("logo_dark"));
		});
	} else {
		$("#checkdarkmode").prop("checked", false);
		$("img.brandLogo").each(function () {
			$(this).attr("src", $(this).data("logo_light"));
		});
	}
	$("#archive_filter_mob").on("click", function (e) {
		e.preventDefault();
		$("#archive_filter_aside").addClass("is_active");
	});

	// header hamburger menu
	$(".sb_header_hamburger").click(function (e) {
		// open hamburger menu
		$(this).addClass("is_active");
		// append overlay to dom
		$(this).before(sb_masker);
		// go one level
		if (
			$(e.target).hasClass("sb_has_submenu") ||
			($(e.target).parent().hasClass("sb_has_submenu") &&
				!e.target.classList.contains("sb_menu_lvl_back"))
		) {
			//  prevent link if not submenu
			if (
				$(e.target).parent().hasClass("sb_has_submenu") &&
				!$(e.target).parent().hasClass("is_current")
			) {
				e.preventDefault();
			}
			$(".sb_menu_lvl_1").addClass("is_active");
			$(e.target).parent().addClass("is_current");
			$(e.target).parent().parent().parent().addClass("is_open is_current");
			let lvlBackText = $(e.target)
				.parent()
				.parent()
				.parent()
				.find(".sb_menu_list_link")
				.html();
			let sb_menu_lvl_back = `<div class="sb_menu_lvl_back sb-bg_lighter_blue sb-bg_transparent_gray is_active">
            <i class="ico ico-angle-right me-2"></i> ${lvlBackText} </div>`;
			// create lvl back
			if (!$(e.target).parent().children().hasClass("sb_menu_lvl_back")) {
				$(e.target).parent().prepend(sb_menu_lvl_back);
			} else {
				$(e.target)
					.parent()
					.find(".sb_menu_lvl_back")[0]
					.classList.add("is_active");
			}
		}
		// back one level
		if (e.target.classList.contains("sb_menu_lvl_back")) {
			console.log($(e.target));
			$(e.target).removeClass("is_active");
			$(e.target)
				.closest(".sb_menu.sb_has_submenu")
				.closest(".is_open")
				.find("ul li.is_current")
				.removeClass("is_current");
			$(e.target)
				.closest(".sb_menu.sb_has_submenu")
				.removeClass("is_current is_open");
			$(e.target)
				.closest(".sb_menu.sb_has_submenu")
				.closest(".is_open")
				.removeClass("is_open");
			if ($(".sb_menu_lvl_back.is_active").length < 1) {
				$(".sb_menu_lvl_1").removeClass("is_active");
				$(".sb_menu_lvl_2").removeClass("is_current is_open");
			}
			if (!$(".sb_menu_lvl_back")[0].classList.contains("is_active")) {
				$(".sb_menu_lvl_1").removeClass("is_active");
				$(".sb_menu_lvl_2").removeClass("is_current is_open");
				$(".sb_menu_lvl_back.is_active").removeClass("is_active");
				$(".sb_menu.sb_has_submenu").removeClass("is_current is_open");
			}
		}
	});
	// footer accordion mobile view
	$(".sb_footer_sitemap_list").click(function () {
		$(this).toggleClass("is_active");
	});

	// ███████████████████████
	// single-product
	// ███████████████████████
	var scrollSpy = new bootstrap.ScrollSpy(document.body, {
		target: "#navbar-example",
	});
	// tab-content product-details
	$(".sb_tab_navs .sb_tab_nav").on("click", function () {
		let navIndex = $(this).index() + 1;
		$(".sb_tab_navs .sb_tab_nav:nth-child(" + navIndex + ")").addClass(
			"active"
		);
		$(".sb_tab_navs .sb_tab_nav:nth-child(" + navIndex + ")")
			.siblings()
			.removeClass("active");
		$(".sb_tab_panes .sb_tab_pane:nth-child(" + navIndex + ")").addClass(
			"active"
		);
		$(".sb_tab_panes .sb_tab_pane:nth-child(" + navIndex + ")")
			.siblings()
			.removeClass("active");
	});
	//single product addons selector
	$(".sb_product_addons_option ").on("click", function () {
		let radioImg = $(this).find("[name=sb_product_addon_select]").data("img");
		$(".sb_product_addons_item").addClass("is-active");
		$(".sb_product_addons_item img").attr("src", radioImg);
	});
	$(".sb_product_addons_item i").on("click", function () {
		$("[name=sb_product_addon_select]").each(function () {
			$(this).prop("checked", false);
			$(".sb_product_addons_item").removeClass("is-active");
		});
	});
	$(".sb_qty_box_minus").on("click", function () { });
	$(".sb_qty_box_minus").on("click", function () { });
	// var singleProductGalleryThumbs = new Swiper(".sb_product_gallery_thumbs", {
	// 	spaceBetween: 10,
	// 	watchSlidesProgress: true,
	// 	grabCursor: true,
	// 	breakpoints: {
	// 		320: {
	// 			slidesPerView: 4,
	// 		},
	// 		768: {
	// 			slidesPerView: 4,
	// 		},
	// 		992: {
	// 			slidesPerView: 6,
	// 		},
	// 		1200: {
	// 			slidesPerView: 8,
	// 		},
	// 	},
	// });
	var singleProductGallerySlider = new Swiper(".sb_product_gallery_slider", {
		loop: false,
		nav: true,
		ally: false,
		preventClicks: true,
		spaceBetween: 20,
		navigation: {
			nextEl: ".swiper-button-next",
			prevEl: ".swiper-button-prev",
		},
		on: {
			slideChange: function (e) {
				var enlargeSrc = $($(".sb_product_gallery_slider .swiper-slide")[this.realIndex]).find('img').data("realimage");
				console.log('enlargeSrc: ' + enlargeSrc);
				$($(".sb_product_gallery_slider .swiper-slide")[this.realIndex]).find('img').attr("src", enlargeSrc);
				$($(".sb_product_view_gallery .swiper-slide")[this.realIndex]).find('img').attr("src", enlargeSrc);
				$("#sb_product_gallery_slider  img").css({
					transform: "rotate(0deg)",
				});
				rotate = 0;
				var offer = document.querySelector('#numberSlides');
				offer.innerHTML = replaceAll(e.activeIndex + 1) + '<span class="mx-2">از</span>' + replaceAll(e.slides.length);
			},
			init: function (e) {
				var offer = document.querySelector('#numberSlides');
				offer.innerHTML = replaceAll(e.activeIndex + 1) + '<span class="mx-2">از</span>' + replaceAll(e.slides.length);
			},
		},
		// thumbs: {
		// 	swiper: singleProductGalleryThumbs,
		// },

	});
	let sliderActiveIndex, sliderPrevActive, originalProductImg;

	$(".sb_product_thumbs .sb_thumb_slide").on("click", function () {
		singleProductViewGgallery.slideTo($(this).index());
	});
	$(".sb_product_thumbs .sb_thumb_content ").each(function () {
		originalProductImg = $(this).children().length;
	});
	$(".sb_customer_thumbs .sb_thumb_slide").on("click", function () {
		singleProductViewGgallery.slideTo($(this).index() + originalProductImg);
	});
	var singleProductSlider = new Swiper(".sb_swiper_product_slider", {
		loop: false,
		freeMode: true,
		preventClicks: true,
		a11y: false,
		spaceBetween: 20,
		breakpoints: {
			320: {
				slidesPerView: 2.5,
			},
			576: {
				slidesPerView: 3.5,
			},
			768: {
				slidesPerView: 4.5,
			},
			992: {
				slidesPerView: 5.5,
			},
		},
	});
	var singleProductTagSlider = new Swiper(".sb_tag_slider", {
		loop: false,
		nav: false,
		spaceBetween: 15,
		navigation: {
			nextEl: ".swiper-box-arrow-next",
			prevEl: ".swiper-box-arrow-prev",
		},
		breakpoints: {
			320: {
				slidesPerView: 2,
			},
			576: {
				slidesPerView: 3,
			},
			768: {
				slidesPerView: 3,
			},
			992: {
				slidesPerView: 4,
			},
			1200: {
				slidesPerView: 8,
			},
		},
	});
	// single review slider
	var singleProductReviewsGalleryThumbs = new Swiper(
		".sb_product_reviews_gallery_thumbs", {
		spaceBetween: 5,
		direction: "horizontal",
		slidesPerView: 3,
		watchSlidesProgress: true,
		breakpoints: {
			0: {
				slidesPerView: 2,
			},
			576: {
				slidesPerView: 3,
			},
			768: {
				spaceBetween: 15,
				slidesPerView: 4,
			},
			992: {
				slidesPerView: 6,
			},
			1200: {
				slidesPerView: 9,
				direction: "vertical",
			},
		},
	}
	);
	var singleProductReviewsGallerySlider = new Swiper(
		".sb_product_reviews_gallery_slider", {
		loop: false,
		freeMode: true,
		nav: true,
		ally: false,
		preventClicks: true,
		spaceBetween: 20,
		navigation: {
			nextEl: ".swiper-button-next",
			prevEl: ".swiper-button-prev",
		},
		thumbs: {
			swiper: singleProductReviewsGalleryThumbs,
		},
	}
	);
	singleProductReviewsGallerySlider.on("slideChange", function () {
		const index_currentSlide = this.realIndex;
		console.log(this.realIndex);
		console.log(this.slides);
		const currentSlideData = this.slides[index_currentSlide].dataset.commentId;
		$(".sb_modal_gallery_reviews .sb_comments_cell").each(function () {
			if ($(this).data("comment-id") == currentSlideData) {
				console.log("this ", $(this).data("comment-id"));
				console.log("activeSlide ", currentSlideData);
				$(this).addClass("is-active");
				$(this).siblings().removeClass("is-active");
			}
		});
	});
	// active first child reviews comment in modal
	$(
		".sb_modal_gallery_reviews .sb_comments_cell:nth-child(" +
		(singleProductReviewsGallerySlider.activeIndex + 1) +
		")"
	).addClass("is-active");
	$('.sb_comments_img[data-bs-target="#modal-comments-gallery"]').on(
		"click",
		function () {
			setTimeout(() => {
				singleProductReviewsGallerySlider.slideTo($(this).data("slider"));
			}, 500);
		}
	);

	$("#commentFormSubmit").on("click", function () {
		let fields = document.querySelectorAll(".cna_validate");
		let validAll = [];
		for (let i = 0; i < fields.length; i++) {
			removeError(fields[i]);
			const element = fields[i];
			validAll.push(checkValidityForm(element));
		}
		if (!validAll.includes(false)) {
			$("#commentForm .loader_container").addClass("d-flex");
			$.ajax({
				method: "POST",
				url: baseURL + "ajax/products/comment",
				data: $("#commentForm form").serialize(),
				success: function (response) {
					$("#commentForm .loader_container").removeClass("d-flex");
					msgbox(response);
					if (response == "دیدگاه شما با موفقیت ثبت شد و پس از بررسی و تایید، نمایش داده خواهد شد.") {
						$("#commentForm form")[0].reset();
						$("#commentForm").modal("hide");
					}
				},
				error: function (errorMessage) {
					$("#commentForm .loader_container").removeClass("d-flex");
					msgbox("خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.");
				},
			});
		}
	});
	// remove error elements on close modal
	var commentFormModal = document.getElementById("commentForm");
	if (commentFormModal != null) {
		commentFormModal.addEventListener("hidden.bs.modal", function (e) {
			let errorElems = e.target.querySelectorAll(".sb-form-error");
			let fields = e.target.querySelectorAll("input.cna_validate");
			errorElems.forEach((errorElem) => {
				errorElem.remove();
			});
			fields.forEach((field) => {
				field.value = "";
			});
		});
	}

	// ███████████████████████
	// Archive Product
	// ███████████████████████
	if (localStorage.getItem("archive_view") == null) {
		localStorage.setItem("archive_view", "grid");
	} else {
		$(".sb_item_cells_wrap").addClass(localStorage.getItem("archive_view"));
	}
	if (localStorage.getItem("archive_view") == "grid") {
		$(".sb_grid_view_btn").addClass("active");
	} else {
		$(".sb_list_view_btn").addClass("active");
	}
	$(".sb_list_view_btn").on("click", function () {
		$(this).addClass("active");
		$(this).siblings().removeClass("active");
		localStorage.setItem("archive_view", "sb_items_list_view");
		$(".sb_item_cells_wrap").addClass("sb_items_list_view");
		$("html, body").scrollTop($("#panelsStayOpen-headingCategories").offset().top - 75);
	});
	$(".sb_grid_view_btn").on("click", function () {
		$(this).addClass("active");
		$(this).siblings().removeClass("active");
		localStorage.setItem("archive_view", "grid");
		$(".sb_item_cells_wrap").removeClass("sb_items_list_view");
		$("html, body").scrollTop($("#panelsStayOpen-headingCategories").offset().top - 75);
	});
	// filter aside archive page checkbox check tree
	$(".sb_filter_box_label i").on("click", function () {
		$(this).closest(".sb_has_submenu").toggleClass("is-active");
		if ($(this).closest(".sb_has_submenu").hasClass("is-active")) {
			$(this)
				.closest(".sb_has_submenu")
				.find(".sb_filter_box_list")
				.slideDown(300, "linear");
		} else {
			$(this)
				.closest(".sb_has_submenu")
				.find(".sb_filter_box_list")
				.slideUp(300, "linear");
		}
	});
	// filterbox checkbox check items
	//  helper function to create nodeArrays (not collections)
	const nodeArray = (selector, parent = document) => [].slice.call(parent.querySelectorAll(selector));
	//  checkboxes of interest
	const allThings = nodeArray(".sb_left_nav input");
	//  global listener
	addEventListener("change", (e) => {
		let check = e.target;
		//  exit if change event did not come from
		//  our list of allThings
		if (allThings.indexOf(check) === -1) return;
		//  check/unchek children (includes check itself)
		const children = nodeArray("input", check.parentNode);
		children.forEach((child) => {
			child.checked = check.checked;
			// $('.sb_filter_box_bottom .sb_btn_tool').removeClass('d-none');
		});
		//  traverse up from target check
		while (check) {
			// $('.sb_filter_box_bottom .sb_btn_tool').removeClass('d-none');
			//  find parent and sibling checkboxes (quick'n'dirty)
			const parent = check.closest(["ul"]).parentNode.querySelector("input");
			const siblings = nodeArray(
				"input",
				parent.closest("li").querySelector(["ul"])
			);
			//  get checked state of siblings
			//  are every or some siblings checked (using Boolean as test function)
			const checkStatus = siblings.map((check) => check.checked);
			const every = checkStatus.every(Boolean);
			const some = checkStatus.some(Boolean);
			//  check parent if all siblings are checked
			//  set indeterminate if not all and not none are checked
			parent.checked = every;
			parent.indeterminate = !every && every !== some;
			//  prepare for next loop
			check = check != parent ? parent : 0;
			// console.log((parent));
			// console.log((parent.closest('li')));
			// if (!parent.checked && !parent.indeterminate) {
			//     console.log('welcome');
			//     $('.sb_filter_box_bottom .sb_btn_tool').addClass('d-none');
			// }
		}
	});
	$(".sb_has_submenu>.sb_filter_box_label>.sb_form_checkbox").on(
		"click",
		function () {
			let propStates = $(this).find("input").prop("checked");
			$(this)
				.closest(".sb_has_submenu")
				.find("li")
				.each(function () {
					$(this).find("input").prop("checked", propStates);
				});
		}
	);

	// cart & checkout

	setTimeout(function () { addressChecked(); }, 100);

	$("[name=address_radio]").on("change", function () {
		addressChecked();
	});

	// checkout validate form and send to create address
	$("#cna_submit").on("click", function () {
		// console.log("cna_submit has been clicked.");
		let fields = document.querySelectorAll(".cna_validate");
		let validAll = [];
		for (let i = 0; i < fields.length; i++) {
			removeError(fields[i]);
			const element = fields[i];
			validAll.push(checkValidityForm(element));
		}
		if (!validAll.includes(false)) {
			$("#createUserAddress .loader_container").addClass("d-flex");
			$.ajax({
				method: "POST",
				url: baseURL + "ajax/users/addressAdd",
				data: $("#checkoutAddrAddForm").serialize(),
				success: function (response) {
					var resObj;
					try {
						resObj = JSON.parse(response);
					} catch (e) {
						console.log("addressAdd result is not JSON");
					}
					if (resObj != undefined) {
						$("#createUserAddress .loader_container").removeClass("d-flex");
						if (
							resObj.msg == "آدرس جدید با موفقیت افزوده شد." ||
							resObj.msg == "تغییرات با موفقیت در آدرس ثبت شد."
						) {
							var defaultStr = "";
							if ($("#checkoutAddrAddForm #flexCheckChecked")[0].checked) {
								defaultStr =
									'<div class="badge sb_badge sb_bg-danger sb_card_default sb_font_m sb_card_default"><span>پیشفرض</span></div>';
								$(".sb_checkout_card_cells .badge").remove();
							}
							if ($("#input_addressID").val() === "0") {
								$(
									"#shippingItemCell .sb_checkout_card_cells, .profileAddressesNotEmpty .sb_checkout_card_cells"
								).append(
									`
								<div class="col-lg-4">
									<div class="sb_item_cell sb_card_wrap p-0">
										<div class="sb_card">
											<label class="sb_card_info" data-address_id="` +
									resObj.addressID +
									`">
												<input type="radio" name="address_radio" class="sb_card_radiobutton checkoutAddrRadio" checked data-tipax_id="` +
									$(
										"#cna_city option[value=" + $("#cna_city").val() + "]"
									).data("tipax_id") +
									`" value="` +
									resObj.addressID +
									`">
												<div class="sb_card_title"><div class="sb_card_nickname">` +
									$("#cna_address_title").val() +
									`</div></div>
												<div class="sb_address_parent">
													<address class="sb_address">
														<div class="sb_address_title fw-bold mb-2">` +
									$("#cna_fullname").val() +
									`</div>
														<div class="mb-2"><span class="sb_address_done_state" data-province_id="` +
									$("#cna_state").val() +
									`">` +
									$(
										"#cna_state option[value=" + $("#cna_state").val() + "]"
									).text() +
									`</span><span> - </span><span class="sb_address_done_city">` +
									$(
										"#cna_city option[value=" + $("#cna_city").val() + "]"
									).text() +
									`</span></div>
														<div class="mb-2">
															<span class="sb_address_done_mobile">` +
									$("#cna_mobile").val() +
									`</span><span> | </span>
															<span class="d-inline-block sb_ltr"><span>` +
									$(
										"#cna_state option[value=" + $("#cna_state").val() + "]"
									).data("state-code") +
									`</span><span> - </span><span class="userAddressTel">` +
									$("#cna_phone").val() +
									`</span></span>
														</div>
														<div class="mb-2 sb_font_m sb_address_done_address">`+ $("#cna_address").val() + `</div>
														کدپستی: <div class="mb-2 sb_font_m sb_address_done_postalCode sb_ltr text-start">`+ $("#cna_postalcode").val() + `</div>
													</address>
												</div>
												` +
									defaultStr +
									`
											</label>
											<div class="d-flex justify-content-end align-items-center sb_card_bottom">
												<button class="sb_btn sb_btn_mini sb_font_s fw-bold me-4" type="button" data-bs-toggle="modal" data-bs-target="#createUserAddress" onclick="addressEdit(this);">ویرایش</button>
												<button class="sb_btn sb_btn_mini sb_font_s fw-bold" type="button" data-bs-toggle="modal" data-bs-target="#removeUserAddress" onclick="$('#cna_removeAddress').data('address_id', ` +
									resObj.addressID +
									`);">حذف</button>
											</div>
										</div>
									</div>
								</div>`
								);
								$(".checkoutAddrRadio")
									.off("change")
									.on("change", function () {
										deliveryPrice();
									});
								profileCheckAddresses();
							} else {
								var labelElem = $(
									"label[data-address_id=" + $("#input_addressID").val() + "]"
								);
								$(labelElem)
									.find(".sb_address_title")
									.text($("#cna_fullname").val());
								$(labelElem)
									.find(".sb_address_done_state")
									.data("province_id", $("#cna_state").val())
									.text(
										$(
											"#cna_state option[value=" + $("#cna_state").val() + "]"
										).text()
									);
								$(labelElem)
									.find(".sb_address_done_city")
									.text(
										$(
											"#cna_city option[value=" + $("#cna_city").val() + "]"
										).text()
									);
								$(labelElem)
									.find(".userAddressTel")
									.text($("#cna_phone").val());
								$(labelElem)
									.find(".sb_address_done_mobile")
									.text($("#cna_mobile").val());
								$(labelElem)
									.find(".sb_address_done_postalCode")
									.text($("#cna_postalcode").val());
								$(labelElem)
									.find(".sb_address_done_address")
									.text($("#cna_address").val());
								$(labelElem)
									.find(".sb_card_nickname")
									.text($("#cna_address_title").val());
								if ($("#checkoutAddrAddForm #flexCheckChecked")[0].checked)
									$(labelElem).after(defaultStr);
							}
							// $("#createUserAddress").modal("hide");
							history.back();
						}
						msgbox(resObj.msg);
						setTimeout(function () {
							// console.log("calling deliveryPrice()...");
							deliveryPrice();
						}, 100);
					} else
						msgbox(
							"خطا! پاسخ دریافتی از سرور پس از افزودن/ویرایش آدرس، نامعتبر است."
						);
				},
				error: function (errorMessage) {
					$("#createUserAddress .loader_container").removeClass("d-flex");
					msgbox(
						"خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید."
					);
				},
			});
		}
	});

	$(".cna_validate").blur(function (e) {
		removeError(e.target);
		checkValidityForm(e.target);
	});
	$("#sb_contactUs_submit").on("click", function () {
		let fields = document.querySelectorAll(".cna_validate");
		let validAll = [];
		for (let i = 0; i < fields.length; i++) {
			removeError(fields[i]);
			const element = fields[i];
			validAll.push(checkValidityForm(element));
		}
		if (!validAll.includes(false)) {
			$.ajax({
				method: "POST",
				url: "",
				data: "",
				success: function (response) { },
				error: function (error) { },
			});
		}
	});
	// remove error eleemnts on close modal
	var createUserAddressModal = document.getElementById("createUserAddress");
	if (createUserAddressModal != null) {
		createUserAddressModal.addEventListener("hidden.bs.modal", function (e) {
			let errorElems = e.target.querySelectorAll(".sb-form-error");
			let fields = e.target.querySelectorAll("input.cna_validate");
			errorElems.forEach((errorElem) => {
				errorElem.remove();
			});
			fields.forEach((field) => {
				field.value = "";
			});
		});
	}
	// show state code be side phone number -> modal create user address
	$("#cna_state").on("change", function (e) {
		$("#cna_show_state_code").text(
			$(this).find(":selected").attr("data-state-code")
		);
	});

	// ███████████████████████
	// PROFILE USER
	// ███████████████████████
	// show hoghughi section -> edit user profile
	$("#ep_h_checkbox").change(function () {
		profileCheckBox(this);
	});
	profileCheckBox("#ep_h_checkbox");

	function profileCheckBox(that) {
		if ($(that).val() == 1) {
			$('[tab-content-menu=hoghughi]').click();
		} else {
			if ($(that).val() == 0) $('#profileInfoHaghighiBtn').click();
			else $('#profileInfoFurushgahBtn').click();
		}
	}
	// change delivery date and time
	$("#deliverySubmit").on("click", function () {
		let checkedDate = $(".sb_checkout_delivery [name=deliveryTime]:checked");
		let activeThumb = $(
			".sb_checkout_delivery_thumb .swiper-slide:nth-child(" +
			(checkedDate.closest(".swiper-slide").index() + 1) +
			")"
		);
		let dayName = activeThumb.find(".day_name").html();
		let day = activeThumb.find(".day").html();
		let month = activeThumb.find(".month").html();
		let year = activeThumb.find(".year").html();
		let hourStart = checkedDate
			.closest(".sb_form_radiobox")
			.find(".sb_hour_start")
			.text();
		let hourEnd = checkedDate
			.closest(".sb_form_radiobox")
			.find(".sb_hour_end")
			.text();
		$(".sb_done_show_date.sb_day_name").html(dayName);
		$(".sb_done_show_date.sb_day").html(day);
		$(".sb_done_show_date.sb_month").html(month);
		$(".sb_done_show_date.sb_year").html(year);
		$(".sb_done_show_date.sb_start_hour").html(hourStart);
		$(".sb_done_show_date.sb_end_hour").html(hourEnd);
	});
	var checkoutDeliveryThumb = new Swiper(".sb_checkout_delivery_thumb", {
		spaceBetween: 10,
		pagination: {
			el: ".swiper-pagination",
		},
		breakpoints: {
			320: {
				slidesPerView: 1,
			},
			576: {
				slidesPerView: 2,
			},
			768: {
				slidesPerView: 3,
			},
			992: {
				slidesPerView: 4,
			},
		},
	});
	var checkoutDelivery = new Swiper(".sb_checkout_delivery", {
		loop: false,
		nav: false,
		keyboard: {
			enabled: false,
		},
		simulateTouch: false,
		navigation: {
			nextEl: ".swiper-button-next",
			prevEl: ".swiper-button-prev",
		},
		thumbs: {
			swiper: checkoutDeliveryThumb,
		},
	});

	$(".sb_quantity_plus").on("click", function (e) {
		e.stopPropagation();
		quantityFunc($(this), "sum");
	});
	$(".sb_quantity_minus").on("click", function (e) {
		e.stopPropagation();
		quantityFunc($(this), "minus");
	});
	cartAjax("refresh");
});

function registerWithPass() {
	console.log("hi");
	msgbox('در حال پردازش، لطفاً شکیبا باشید...');
	$.ajax({
		url: baseURL + "ajax/users/loginRegister",
		type: "POST",
		data: {
			userMobile: $("input[name=sb_reg_user_data]").val(),
			pass1: $("input[name=sb_reg_pass1]").val(),
			pass2: $("input[name=sb_reg_pass2]").val(),
			userRequest: "registerWithPass"
		},
		success: function (response) {
			response = JSON.parse(response);
			if (response.error != undefined) msgbox(response.error);
			else if (response.loginSuccessful) { msgbox('ثبت نام شما انجام شد! در حال انتقال...'); document.location = document.location.origin + document.location.pathname; }
			else msgbox('خطای نامشخصی رخ داده است.');
		},
		error: function () {
			msgbox('خطا در اتصال! از کارکردِ صحیحِ اینترنتتان اطمینان حاصل کرده و مجدداً تلاش کنید.');
		}
	});
}

// ███████████████████████
// Document Click
// ███████████████████████
// end ready func
$(document).on("click", function (e) {
	//active search in header
	let $trigger_header_menu = $(".sb_header_hamburger");
	let $archive_filter_aside = $("#archive_filter_aside");
	let $archive_filter_btn = document.getElementById("archive_filter_mob");
	let $headerCartBtn = document.querySelector(".sb_header_cart");
	// archive sidebar
	if ($archive_filter_aside.hasClass("is_active")) {
		if (
			$archive_filter_btn !== e.target &&
			$archive_filter_aside !== e.target &&
			!$archive_filter_aside.has(e.target).length
		) {
			$archive_filter_aside.removeClass("is_active");
		}
	}
	// cart overlay
	if ($(".sb_cart_overlay").hasClass("is_active")) {
		if (
			$headerCartBtn !== e.target.parentElement.parentElement &&
			$(".sb_cart_overlay") !== e.target &&
			!$(".sb_cart_overlay").has(e.target).length) {
			$(".sb_cart_overlay").removeClass("is_active");
		}
	}

	if ($trigger_header_menu.hasClass("is_active")) {
		if (
			$trigger_header_menu !== e.target &&
			!$trigger_header_menu.has(e.target).length
		) {
			$trigger_header_menu.removeClass("is_active");
			$trigger_header_menu
				.closest(".sb_header_right_section")
				.find(".sb_masker")
				.remove();
		}
	}
	//  remove sb_masker 
	if (!$('.sb_modal_dialog').has(e.target).length && !$(e.target).closest('[sb-modal-trigger]').length > 0 && $(e.target).hasClass('sb_masker')) {
		// $(sb_masker).remove(); hideModal($('.sb_modal'));
		history.back();
		pullToRefresh.destroy();
	}
});
// homepage side menu
document.addEventListener("DOMContentLoaded", function () {
	// make it as accordion for smaller screens
	if (window.innerWidth < 992) {
		document.querySelectorAll(".nav-link").forEach(function (element) {
			element.addEventListener("click", function (e) {
				let nextEl = element.nextElementSibling;
				let parentEl = element.parentElement;
				let allSubmenus_array = parentEl.querySelectorAll(".submenu");
				if (nextEl && nextEl.classList.contains("submenu")) {
					e.preventDefault();
					if (nextEl.style.display == "block") {
						nextEl.style.display = "none";
						console.log(nextEl);
						// nextEl.removeClass('account_active');
						parentEl.parentElement.querySelector(".sb_masker").remove();
					} else {
						$(".sb_header_account").before(sb_masker);
						nextEl.style.display = "block";
					}
				}
			});
		});
	}
});

// countdown
function setCountDown(featureDate, selector) {
	var getFeatureDate = new Date(featureDate).getTime();
	let elements = `<span></span><i class="sb_colon">:</i><span></span><i class="sb_colon">:</i><span></span>`;
	if ($("#" + selector).length > 0) {
		var selector_ = document.getElementById(selector);
		selector_.innerHTML = elements;
	}
	let timer = setInterval(() => {
		let now = new Date().getTime();
		let distance = getFeatureDate - now;
		let days = Math.floor(distance / (1000 * 60 * 60 * 24));
		let hours = Math.floor(
			(distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60) + (days * 24)
		);
		let minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
		let seconds = Math.floor((distance % (1000 * 60)) / 1000);
		$(selector_).children()[0].innerHTML = seconds;
		$(selector_).children()[2].innerHTML = minutes;
		$(selector_).children()[4].innerHTML = hours;
		// $(selector_).children()[6].innerHTML = replaceAll(days);
		if (distance < 0) {
			clearInterval(timer);
			document.getElementById(
				selector
			).innerHTML = `<span class="sb_countdown_expired">منقضی شد</span>`;
			$(".sb_section_coutdown_label ").addClass("d-none");
		}
	}, 1000);
}

$(".sb_rotate_img").on("click", function () {
	rotate += 90;
	let img = $("#sb_product_gallery_slider .swiper-slide-active img");
	rotate == 360 ? (rotate = 0) : (rotate = rotate);
	img.css({
		transform: "rotate(" + rotate + "deg)",
	});
});

const swiper = new Swiper(".sb_event_box_swiper", {
	// Optional parameters
	freeMode: true,
	slidesPerView: 'auto',
	navigation: {
		nextEl: ".swiper-button-next",
		prevEl: ".swiper-button-prev",
	},
});


// pwa
const pwaProductSlider = new Swiper(".pwa_product_slider", {
	// Optional parameters
	freeMode: true,
	slidesPerView: 'auto',
	navigation: {
		nextEl: ".swiper-button-next",
		prevEl: ".swiper-button-prev",
	},
	breakpoints: {
		320: {
			slidesPerView: 2,
		},
		576: {
			slidesPerView: 2,
		},
		768: {
			slidesPerView: 4,
		},
		992: {
			slidesPerView: 6,
		},
		1200: {
			slidesPerView: 10,
		},
	},
});

const pwaProfileMenu = new Swiper(".pwa_profile_menu_slider", {
	// Optional parameters
	// freeMode: true,
	hashNavigation: true,
	slidesPerView: 2.5,
	centeredSlides: true,
	navigation: {
		nextEl: ".swiper-button-next",
		prevEl: ".swiper-button-prev",
	},
	slideToClickedSlide: true,
});

const pwaProfileSlider = new Swiper(".pwa_profile_slider", {
	// Optional parameters
	// freeMode: false,
	spaceBetween: 30,
	centeredSlides: true,
	hashNavigation: true,
	slidesPerView: 1,
	navigation: {
		nextEl: ".swiper-button-next",
		prevEl: ".swiper-button-prev",
	},
	// hashNavigation: {
	// 	watchState: true,
	// },
});
pwaProfileSlider.controller.control = pwaProfileMenu;
pwaProfileMenu.controller.control = pwaProfileSlider;

$('[tab-content-menu]').click(function (e) {
	e.preventDefault();
	let tabContentMenu = $(this).attr('tab-content-menu');

	$(this).closest('[tab-content-menu-parent]').find('.btn.sb_btn-primary').removeClass('sb_btn-primary');
	$(this).find('.btn').addClass('sb_btn-primary');
	$('[tab-content-content]').each(function () {
		if ($(this).attr('tab-content-content') == tabContentMenu) {
			$(this).addClass('active').siblings().removeClass('active');
		}
	});
});

function openModal(modal) {
	pullToRefresh.destroy();

	modal.addClass('d-block');
	modal.append(sb_masker);
	setTimeout(() => {
		modal.addClass('show');
	}, 100);
	$('body').addClass('noscroll');
}

function hideModal(modal) {
	modal.removeClass('show');
	setTimeout(() => {
		modal.removeClass('d-block');
	}, 100);
	$('body').removeClass('noscroll');
}

function openModalAssign() {
	$('[sb-modal-trigger]').click(function (e) {
		e.preventDefault();
		let trigger = $(this).attr('sb-modal-trigger');
		document.location.hash = '#SBM' + trigger;

		// destroy the PullToRefresh EventListeners when you open your modal
		// pullToRefresh.destroy();

		$('.sb_modal_close, .sb_masker').off("click");
		$('.sb_modal_close, .sb_masker').on("click", function () {
			history.back();
			// re-initialize PullToRefresh when you close your modal
			initPullToRefresh();
		});
	});
}
openModalAssign();

// check if modal is modal-page
var modalPage = document.querySelectorAll('.sb_modal_page');
modalPage.forEach(element => {
	element.addEventListener('show.bs.modal', modalPageOpened);
	element.addEventListener('hidden.bs.modal', modalPageClosed);
});
function modalPageOpened(param) {
	$('body').addClass('sb_modal_page');
	pullToRefresh.destroy();
}

function modalPageClosed(param) {
	$('body').removeClass('sb_modal_page');
}


// PWA NAVIGATION
$('.pwa_state').click(function (e) {
	window.history.go(-1);
	initPullToRefresh();
});
$('#arrowBackBtn').click(function (e) { window.history.go(-1); });
// $(document).ready(function () {
// 	checkShowArrowBackPwa();
// });

// function checkShowArrowBackPwa() {
// 	if (history.state == null) {
// 		$('#arrowBackBtn').removeClass('d-none');
// 	} else {
// 		$('#arrowBackBtn').addClass('d-none');
// 	}
// }

function PWAhideAll() {
	$('.modal').modal('hide');
	hideModal($('.sb_modal'));
	$('.sb_cart_overlay').removeClass('is_active');
	$('body').removeClass("sb_basket_open");
	$(sb_masker).remove();
}

window.addEventListener('popstate', e => {
	PWAhideAll();
});

function pwaStateClickAssign() {
	$('[pwa-state]').click(function (e) {
		e.preventDefault();

		let url = window.location.href;
		let lastUrlPart = url.substring(url.lastIndexOf('#'));
		lastUrlPart = lastUrlPart.slice(0, 1);
		if (lastUrlPart == '#') {
			history.replaceState('pwaState', null, $(this).attr('pwa-state'))
			stateShowModal($(this).attr('pwa-state'));
		} else {
			history.pushState(null, null, $(this).attr('pwa-state'));
			stateShowModal($(this).attr('pwa-state'));
		}
		// checkShowArrowBackPwa();
	});
}
pwaStateClickAssign();

function stateShowModal(stateName) {
	switch (stateName) {
		case '#basket':
			PWAhideAll();
			cartAjax("open&refresh");
			pullToRefresh.destroy();
			break;
		case '#categories':
			PWAhideAll();
			$("#categoriesModal").modal("show");
			pullToRefresh.destroy();
			break;
		case '#login':
			PWAhideAll();
			$("#register_login_modal").modal("show");
			break;
		case "#search":
			PWAhideAll();
			$("#pwaSearchModal").modal("show");
			interactHeaderSearch();
			windowResize();
			break;

		case "#newComment":
			PWAhideAll();
			$("#commentForm").modal("show");
			break;

		case "#newAddress":
			PWAhideAll();
			$("#createUserAddress").modal("show");
			break;
		default:
			PWAhideAll();
			if (document.location.hash.substr(1, 3) == "SBM") {
				var trigger = document.location.hash.substr(4, trigger = document.location.hash.length - 4);
				setTimeout(function () { openModal($("#" + trigger)); }, 100);


			}
			break;
	}
}

$('[data-catlvl0id]').click(function (e) {
	e.preventDefault();
	let tabId = $(this).attr('data-catlvl0id');
	$(this).addClass('active');
	$(this).siblings().removeClass('active');
	$('.sb_pwa_categories_content ').each(function () {
		if ($(this).attr('id') == tabId) {
			$(this).addClass('active');
			$(this).siblings().removeClass('active');
		}
	});
});


// COMPARE
const swiper_compare = new Swiper(".sb_compare_items_swiper", {
	direction: "horizontal",
	freeMode: true,
	loop: false,
	nav: false,
	slidesPerView: 'auto',
	spaceBetween: 10,
});

class Comp {
	static product = [];
	limitItems = 5;
	constructor() {
		Comp.product = localStorage.getItem('compItems') != null ? JSON.parse(localStorage.getItem('compItems')) : [];
	}
	static productObj(productObj, isAdd) {
		if (isAdd) {
			this.product.push(productObj);
			return this.product;
		} else {
			this.product = this.product.filter(product => product.productId != productObj.productId);
			return this.product;
		}
	}

	compAdd(productObj) {
		if (this.checkLimit()) {
			localStorage.setItem('compItems', JSON.stringify(Comp.productObj(productObj, true)));
			this.createCard();
			this.compShow();

		} else {
			msgbox(`حداکثر ${this.limitItems} محصول برای مقایسه وارد کنید`, { title: 'محدودیت مقایسه' });
			makeCompOnPageWork();
		}
	}

	compRemove(productObj) {
		localStorage.setItem('compItems', JSON.stringify(Comp.productObj(productObj, false)));
		this.createCard();
		this.compShow();
		if (Comp.product.length < 1) {
			this.compHide();
		}
	}

	checkLimit() {
		if (Comp.product.length >= this.limitItems) {
			return false
		} else {
			return true;
		}
	}

	createCard() {
		let lastProductIndex = 0;
		Comp.product.forEach((product, index) => {

			if (document.querySelector('.sb_compare_items_swiper .swiper-slide:nth-child(' + (index + 1) + ').sb_compare_tray_item') != null) {
				document.querySelector('.sb_compare_items_swiper .swiper-slide:nth-child(' + (index + 1) + ').sb_compare_tray_item').classList.remove('sb_compare_tray_item');
			}
			const createTemplate = `
			<div class="sb_slab_inner" data-product-id="${product.productId}">
				<div class="sb_slab_inner_body">
					<div class="sb_slab_info">
						<div class="d-flex align-items-center">
							<div class="sb_goods_img">
								<img src="${product.productImg}" alt="">
							</div>
						<div class="sb_slab_actions">
							<span class="button no-border slab-del"><i class="ico ico-times" aria-label="remove"></i></span>
						</div>
				    </div>
			    </div>
		    </div>`;
			document.querySelector('.sb_compare_items_swiper .swiper-slide:not(.sb_compare_tray_item)').innerHTML = createTemplate;
			document.querySelector('.sb_compare_items_swiper .swiper-slide:not(.sb_compare_tray_item)').classList.add('sb_compare_tray_item');
			lastProductIndex = index;

			// remove items on slider button delete
			let compObj = this;
			document.querySelectorAll('.sb_slab_actions').forEach(action => {
				action.onclick = function (e) {
					let slideItemProductId = {
						'productId': e.currentTarget.closest('.sb_slab_inner').dataset.productId
					};
					compObj.compRemove(slideItemProductId);
					makeCompOnPageWork();
				}
			})
		});

		for (let i = Comp.product.length + 1; i <= 5; i++) {
			const emptyTemplate = `
			<div class="sb_slab_inner">
				<div class="sb_compare_tip_text">${replaceAll(i)}</div>
				</div>
			</div>
			`;
			document.querySelector('.sb_compare_items_swiper .swiper-slide:nth-child(' + i + ')').innerHTML = emptyTemplate;
			document.querySelector('.sb_compare_items_swiper .swiper-slide:nth-child(' + i + ')').classList.remove('sb_compare_tray_item');
		}
	}

	compShow() {
		document.querySelector('.sb_compare_items').classList.remove('d-none');
		document.querySelector('.sb_empty_compare_text').classList.add('d-none');
	}

	compHide() {
		document.querySelector('.sb_compare_items').classList.add('d-none');
		document.querySelector('.sb_empty_compare_text').classList.remove('d-none');
	}

	startCompare() {
		const arr = Comp.product.map(product => {
			return product.productId;
		});
		window.open(baseURL + "compare?productsToCompare=[" + arr + "]", "_blank");
	}

	removeAll() {
		localStorage.removeItem('compItems');
		this.compHide();
		makeCompOnPageWork();
	}
}
let compObj;
const compCheckboxChange = (e) => {
	const newTarget = e.target == undefined ? e : e.target;
	const cardParent = e.target == undefined ? e.closest('.product_id') : e.target.closest('.product_id');
	const productId = cardParent.id;
	const productImg = cardParent.querySelector('.sb-comp_img').src;

	const productItem = {
		productId,
		productImg,
	};

	compObj = new Comp();
	if (newTarget.checked) {
		compObj.compAdd(productItem)
		document.querySelector('.sb_compare_list').classList.add('active');

	} else {
		compObj.compRemove(productItem);
	}
	compareSetTime();
	// go to next slide on add items
	setTimeout(() => {
		if (document.querySelectorAll('.sb_compare_tray_item').length > 0) {
			let allSliderActiveItems = document.querySelectorAll('.swiper-slide.sb_compare_tray_item');
			const lastSlideIndex = allSliderActiveItems.length - 1;
			if (allSliderActiveItems[allSliderActiveItems.length - 1].getBoundingClientRect().left < 150) {
				swiper_compare.slideTo(lastSlideIndex - 1);
			}
		}
	}, 0);
}

const compCheckboxs = document.querySelectorAll('.sb_item_compare_box');
compCheckboxs.forEach(compcheckbox => {
	compcheckbox.addEventListener('change', compCheckboxChange);
});

function makeCompOnPageWork() {
	let newbool = true;
	let compItems = JSON.parse(localStorage.getItem('compItems')) || 0;
	compCheckboxs.forEach(compcheckbox => {
		compcheckbox.querySelector('input').checked = false;
		compcheckbox.closest('.product_id').classList.remove('active');
	});
	compObj = new Comp();
	compObj.createCard();
	if (typeof compItems == 'object' && compItems.length > 0) {
		compObj.compShow();
		compItems.forEach(item => {
			if (document.getElementById(item.productId) != null) {
				document.getElementById(item.productId).querySelector('.sb_item_compare_box input').checked = true;
				document.getElementById(item.productId).classList.add('active');
				compObj.compShow();
			}
		});
	} else if (typeof compItems != 'object' || compItems.length == 0) {
		compObj.compHide();
	}

}


window.onfocus = function () {
	makeCompOnPageWork();
}

makeCompOnPageWork();

function compareSetTime() {
	const interval = setInterval(() => {
		makeCompOnPageWork();
		setTimeout(() => {
			clearInterval(interval);
		}, 0);
	}, 1000);
}

compareSetTime();
// open compare list
var archiveCompareButton = document.getElementById('archiveCompareArchive');
if (archiveCompareButton != null) {
	archiveCompareButton.addEventListener('click', archiveCompareFunc);
}


function archiveCompareFunc(e) {
	e.currentTarget.classList.toggle('active');
	document.querySelector('.sb_compare_list').classList.toggle('active');
	if (document.querySelector('.row.sticky-top')) {
		document.querySelector('.row.sticky-top').style.marginBottom = '95px';
	}
	if (e.currentTarget.classList.contains('active')) {
		document.querySelectorAll('.sb_items_list_view .sb_item_cell').forEach(element => {
			element.classList.add('readyToCompare');
		});
		// Show the div when #archiveCompare is clicked
		document.querySelectorAll('.sb_item_compare_box').forEach(element => {
			element.style.display = 'block';
		});;
		document.querySelectorAll('.readyToCompare').forEach(cards => {
			cards.addEventListener('click', chooseForCompare);
		});
	} else {
		if (document.querySelector('.row.sticky-top')) {
			document.querySelector('.row.sticky-top').style.marginBottom = '0';
		}
		document.querySelectorAll('.sb_items_list_view .sb_item_cell').forEach(element => {
			element.removeEventListener('click', chooseForCompare);
			element.classList.remove('readyToCompare');
			element.querySelector('.sb_item_compare_box').style.display = 'none';
		});
	}
}


function chooseForCompare(e) {
	e.preventDefault();
	e.currentTarget.classList.toggle('active');
	if (!e.currentTarget.classList.contains('active')) {
		e.currentTarget.querySelector('.sb_item_compare_box  input').checked = false;
	} else {
		e.currentTarget.querySelector('.sb_item_compare_box  input').checked = true;
	}
	compCheckboxChange(e.currentTarget.querySelector('.sb_item_compare_box  input'));
}

document.querySelector('#compare').onclick = function (e) {
	compObj.startCompare();
};

// ===================== COMPARE PAGE

function highlightDifferences() {
	let tdTextArray = [];
	$('.sb_compare_table tr:not(.sb_compare_first_row):not(.sb_compare_group_title)').each(function () {
		let tr = $(this);
		tr.find('td').each(function () {
			tdTextArray.push($(this).text().trim());
		});
		let isEqual = tdTextArray.every((element, index, arr) => element === arr[0]);
		let allEmpty = tdTextArray.every((element, index, arr) => element === "-");
		if (allEmpty) {
			tr.remove();
		} else if (!isEqual) {
			tr.addClass('sb_compare_highlight_diff');
		}
		tdTextArray = [];
	});
}

function highlightSimilarities() {
	let tdTextArray = [];
	$('.sb_compare_table tr:not(.sb_compare_first_row):not(.sb_compare_group_title)').each(function () {
		let tr = $(this);
		tr.find('td').each(function () {
			tdTextArray.push($(this).text().trim());
		});
		let isEqual = tdTextArray.every((element, index, arr) => element === arr[0]);
		let allEmpty = tdTextArray.every((element, index, arr) => element === "-");
		if (allEmpty) {
			tr.remove();
		} else if (isEqual) {
			tr.addClass('sb_compare_highlight_sim');
		}
		tdTextArray = [];
	});
}

$(document).ready(function () {
	highlightDifferences();
	highlightSimilarities();
	$('.sb_highlight_diffrences_toggle').click(function (e) {
		$('.sb_compare_highlight_diff').toggleClass('diff_active');
	});
	$('.fj_highlight_similarities_toggle').click(function (e) {
		$('.sb_compare_highlight_sim').toggleClass('sim_active');
	});
});

$(document).ready(function () {
	$('.sb_highlight_diffrences_toggle').change(function () {
		if (this.checked) {
			$('.sb_highlight_diffrences_toggle').prop('checked', true);
		} else {
			$('.sb_highlight_diffrences_toggle').prop('checked', false);
		}
	});
});

$(document).ready(function () {
	$('.fj_highlight_similarities_toggle').change(function () {
		if (this.checked) {
			$('.fj_highlight_similarities_toggle').prop('checked', true);
		} else {
			$('.fj_highlight_similarities_toggle').prop('checked', false);
		}
	});
});

// scroll product compare page 
if ($('[data-highlight]').length > 0) {
	document.querySelector("[data-highlight]").addEventListener("scroll", scrollCompareContainer);
	document.querySelector(".sb_compare_items_bar .sb_compare_container").addEventListener("scroll", scrollCompareItemBar);
}

function scrollCompareContainer() {
	var elmnt = document.querySelector("[data-highlight]");
	var elmnt2 = document.querySelector(".sb_compare_items_bar .sb_compare_container");
	elmnt2.scrollLeft = elmnt.scrollLeft;
}

function scrollCompareItemBar() {
	var elmnt = document.querySelector("[data-highlight]");
	var elmnt2 = document.querySelector(".sb_compare_items_bar .sb_compare_container");
	elmnt.scrollLeft = elmnt2.scrollLeft;
}

$('.sb_compare_remove').click(async function (e) {
	e.preventDefault();
	removeItemComparePage($(this), false);
});

let compareLastItemModal
if (document.getElementById('compareModal')) {
	compareLastItemModal = new bootstrap.Modal(document.getElementById('compareModal'), {
		keyboard: false
	});
}
const removeItemComparePage = (target, lastItem) => {

	let productId = target.attr('product-id');
	let url = window.location.href;
	let lastUrlPart = url.substring(url.lastIndexOf('['));
	let queryStringArr = JSON.parse(lastUrlPart);
	const index = queryStringArr.indexOf(parseInt(productId));
	queryStringArr.splice(index, 1);
	const removeItemChangeUrl = (removeAll) => {
		if (removeAll) {
			history.replaceState('productCompare', "", 'compare?productsToCompare=[]');
			return;
		}
		history.replaceState('productCompare', "", 'compare?productsToCompare=' + '[' + queryStringArr + ']');
		let tdIndex = target.parent().index();
		$('tr:not(.sb_compare_group_title) td:nth-child(' + (tdIndex + 1) + ')').each(function () {
			$(this).remove();
		});
	}

	if (lastItem) {
		removeItemChangeUrl(true);
		compareLastItemModal.hide();
		window.location.replace(baseURL);
		return;
	}

	if (queryStringArr.length > 0) {
		removeItemChangeUrl();
	} else {
		compareLastItemModal.show();
	}
}

//  compare table drag
if ($('.sb_compare_items_bar_container').length > 0) {
	const compareItemBar = document.querySelector('.sb_compare_items_bar_container');
	const compareTable = document.querySelector('.sb_compare_container:not(.sb_compare_items_bar_container)');
	let pos;
	const mouseDownHandler = function (e) {
		pos = {
			left: compareTable.scrollLeft,
			top: compareTable.scrollTop,
			x: e.clientX,
			y: e.clientY,
		};
		compareTable.style.cursor = 'grabbing';
		compareTable.style.userSelect = 'none';

		document.addEventListener('mousemove', mouseMoveHandler);
		document.addEventListener('mouseup', mouseUpHandler);
	};

	const mouseMoveHandler = function (e) {
		const dx = e.clientX - pos.x;
		compareTable.scrollLeft = pos.left - dx;
	};

	const mouseUpHandler = function () {
		document.removeEventListener('mousemove', mouseMoveHandler);
		document.removeEventListener('mouseup', mouseUpHandler);

		compareTable.style.cursor = 'grab';
		compareTable.style.removeProperty('user-select');
	};
	compareTable.addEventListener('mousedown', mouseDownHandler);
	compareItemBar.addEventListener('mousedown', mouseDownHandler);
}


const developers = () => {
	let url = window.location.href;
	let lastUrlPart = url.substring(url.lastIndexOf('search/developers'));
	let developersModal;

	if (lastUrlPart == 'search/developers') {
		if ($('#developersModal').length > 0) {
			developersModal = new bootstrap.Modal(document.getElementById('developersModal'), {
				keyboard: false
			});
			$('#Matrix').removeClass('d-none');
			developersModal.show();
			setInterval(draw, 30);
			const drawFile = `<script id="drawFile" src="https://unpkg.com/typeit@8.7.1/dist/index.umd.js" defer></script>`;
			$('head').append(drawFile);
			setTimeout(() => {
				new TypeIt("#developerTypeIt", {
					waitUntilVisible: true,
					strings: ["<div class='d-flex align-content-center'><span class='sb-developers_position_name ms-2 mb-0'>CTO: </span><span class='sb-developers_position_value'>Arash kheirmohammad</span></div>", "<div class='d-flex align-content-center'><span class='sb-developers_position_name ms-2 mb-0'>Back-end lead: </span><span class='sb-developers_position_value'>Siavash norouzi</span></div>", "<div class='d-flex align-content-center'><span class='sb-developers_position_name ms-2 mb-0'>Back-end developer: </span><span class='sb-developers_position_value'>Amirreza jananfar</span></div>", "<div class='d-flex align-content-center'><span class='sb-developers_position_name ms-2 mb-0'>Front-end developer: </span><span class='sb-developers_position_value'>Shahab sabbaghian</span></div>"],
					speed: 75,
					loop: false,
					breakLines: true,
					nextStringDelay: 750,
					waitUntilVisible: true,
					startDelete: true,
					html: true
				}).pause(1000)
					.type("<br>for more information contact us")
					.pause(1000)
					.type("<br>best regards.")
					.go();
			}, 500);
		} else {
			$('#Matrix').addClass('d-none');
			$('#drawFile').remove();
		}
	}
}

const canvas = document.getElementById('Matrix');
const context = canvas.getContext('2d');

canvas.width = window.innerWidth;
canvas.height = window.innerHeight;

const katakana = 'アァカサタナハマヤャラワガザダバパイィキシチニヒミリヰギジヂビピウゥクスツヌフムユュルグズブヅプエェケセテネヘメレヱゲゼデベペオォコソトノホモヨョロヲゴゾドボポヴッン';
const latin = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
const nums = '0123456789';

const alphabet = katakana + latin + nums;
const fontSize = 16;
const columns = canvas.width / fontSize;

const rainDrops = [];

for (let x = 0; x < columns; x++) {
	rainDrops[x] = 1;
}

const draw = () => {
	context.fillStyle = 'rgba(0, 0, 0, 0.05)';
	context.fillRect(0, 0, canvas.width, canvas.height);

	context.fillStyle = '#0F0';
	context.font = fontSize + 'px monospace';

	for (let i = 0; i < rainDrops.length; i++) {
		const text = alphabet.charAt(Math.floor(Math.random() * alphabet.length));
		context.fillText(text, i * fontSize, rainDrops[i] * fontSize);

		if (rainDrops[i] * fontSize > canvas.height && Math.random() > 0.975) {
			rainDrops[i] = 0;
		}
		rainDrops[i]++;
	}
};

developers();

const mouseMoveHandler = function (e) {
	const dx = e.clientX - pos.x;
	compareTable.scrollLeft = pos.left - dx;
};

const mouseUpHandler = function () {
	document.removeEventListener('mousemove', mouseMoveHandler);
	document.removeEventListener('mouseup', mouseUpHandler);

	compareTable.style.cursor = 'grab';
	compareTable.style.removeProperty('user-select');
};


// if (compareTable) {
// 	compareTable.addEventListener('mousedown', mouseDownHandler);
// 	compareItemBar.addEventListener('mousedown', mouseDownHandler);
// }

let profilePictureIcon = document.querySelector(".change-profile-picture-icon");
let avatarSelectBox = document.querySelector(".avatar-select-box");



try {
	profilePictureIcon.addEventListener("click", function () {
		$('.avatar-select-box').toggleClass('active');
	});
} catch (error) {
	// Handle the error here
	// console.error("An error occurred:", error);
}


$('[data-avatar-id]').on('click', function () {
	var avatarId = $(this).data('avatar-id');
	$.ajax({
		url: baseURL + "ajax/users/changeAvatar",
		type: "POST",
		data: {
			avatarId: avatarId,
		},
		success: function (response) {
			$(".avatar_img").attr("src", baseURL + 'assets/img/avatar/' + avatarId + '.svg');
		}
	});
});
$(document).ready(
	$.ajax({
		url: baseURL + "ajax/users/getAvatar",
		success: function (response) {
			let avatarId = response;
			$(".avatar_img").attr("src", baseURL + 'assets/img/avatar/' + avatarId + '.svg');
			let avatarUrl = baseURL + 'assets/img/avatar/' + avatarId + '.svg';
			$(".avatar_container").html('<img src="' + avatarUrl + '" class="avatar_img" />');

		}
	})
);







$(document).ready(function () {
	const liItems = $('#pwa_home, #pwa_categories, #pwa_blog, #pwa_cart, #registerLoginModalBtn');
	const productProfileRegex = /(product|profile)/gm;

	const setActiveItem = (itemId) => {
		liItems.removeClass('active');
		$(itemId).addClass('active');
	};

	liItems.on('click', function () {
		setActiveItem(this);
	});

	$('#pwa_home').on('click', function () {
		setActiveItem(this);
		initPullToRefresh()
	});

	liItems.first().click();

	const currentPath = window.location.pathname;
	const currentHash = location.hash;

	if (currentPath.endsWith('/m/')) {
		$('#arrowBackBtn').hide();
	}
	if (currentHash === '#categorie' || currentPath.includes('/m/category/')) {
		setActiveItem('#pwa_categories');
	} else if (currentHash === '#basket') {
		setActiveItem('#pwa_cart');
	} else if (currentHash === '#login') {
		setActiveItem('#registerLoginModalBtn');
	}
	else {
		if (currentPath.includes('product') || currentPath.includes('profile')) {
			liItems.removeClass('active');
		}
		if (currentPath.includes('profile')) {
			pullToRefresh.destroy();
		}
	}

});

function initPullToRefresh() {
	var refresher = PullToRefresh.init({
		mainElement: '.sb_site_wrapper',
		onRefresh: function () {
			location.reload();
		}
	});

	return {
		destroy: function () {
			refresher.destroy();
		}
	};
}

// usage
var pullToRefresh = initPullToRefresh();
// when you want to destroy
pullToRefresh.destroy();



$(window).scroll(function () {
	if ($(this).scrollTop() > 500) {
		$('.sb_product_addons_wrap').addClass("add-border");
	} else {
		$('.sb_product_addons_wrap').removeClass("add-border");
	}
});

$("#fj_chat").click(function () {
	Goftino.open();
	setTimeout(function () { $("#goftino_w").show(); }, 500);
});

window.addEventListener('goftino_closeWidget', function () {
	$("#goftino_w").hide();
});

function productShare(title, text, productSlug) {
	if (navigator.share) {
		navigator.share({
			title: title,
			text: text,
			url: baseURL + "product/" + productSlug
		})
			.then(() => console.log('Successful share'))
			.catch(error => console.log('Error sharing:', error));
	} else msgbox('لینکِ محصول: <span dir="ltr"><a href="' + baseURL + "product/" + productSlug + '" target="_blank">' + baseURL + "product/" + productSlug + '</a></span>', 'اشتراک گذاری');
}